#!/bin/bash
# routine to extract relevant data form pwscf-output file
# USAGE: ./auswert.bash -i "opt_0001.out opt_0002.out  opt_0007.out opt_0008.out opt_0009.out opt_0010.out" 
# USAGE: generate input list: c=() ; for fon in *out ; do grep " Writing output data " $fon > /dev/null && c=(${c[*]} ${fon}) ; done ; echo ${c[*]} 

typeset -i i j m

lis=`ls *out`
ofi=naliz.dat

while getopts i:o: opt
do
 case $opt in
  i) lis="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib

echo "nam en[Ry] tot_mag[mu_B] abs_mag[mu_B] sig_x[kbar] sig_y[kbar] sig_z[kbar] no_1 occ_up_1 occ_dn_1 ..." > $ofi

for ifi in ${lis} ; do 
{
 hstr=`pw_getocc.bash -i ${ifi}`
 c=(`echo "${hstr}" | sed -n '/enter write_ns/='`) ; m=${#c[*]}-1
 #echo "c: ${c[*]} c[-1]: ${c[${m}]}"
 hstr=`echo "${hstr}" | sed -n "${c[${m}]},$ { /write/d ; p; }" | awk '{ print $2" "$4" "$5 }'`
 mt=(`sed -n '/total   stress/,/Writing/{ /e/d ; p ; } ' ${ifi} `) ;
 ti=`echo ${ifi} | sed 's/mag_// ; s/.out//'`
 en=`grep "!    total energy" ${ifi} | tail -1 | awk '{ print $5 }'`
 tm=`grep "total magnetization " ${ifi} | tail -1 | awk '{ print $4 }'`
 am=`grep "absolute magnetization  " ${ifi} | tail -1 | awk '{ print $4 }'`
 echo "${ti} ${en} ${tm} ${am} ${mt[3]} ${mt[10]} ${mt[17]}" ${hstr} >> .hef.$$
} & 
done
wait

sort .hef.$$ >> ${ofi}
sed '/mag/d ; s/\_/ /g ; s/\-/ -/g ' ${ofi} | awk '{ print $3 " " $4}' > .hef.$$
matica_export 0 1 . .hef.$$
rm .hef.$$
cat $ofi
exit
