#!/bin/bash
# routine to

typeset -i i j nsna

ifi=xas.out
pim=0
silent=true

while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
export PATH=${PATH}:${SCRIPTPATH}
pwd

j=0
for fon in snap*[0-9][0-9][0-9][0-9][0-9].xyz ; do # snap_00000000000007.xyz
 inx=`echo $fon | sed 's/_/ /g ; s/\./ /g' | awk '{ print $2 }'`
 nf=(`sed 1,2d $fon  | sed -n '/[A-Z]/p' | awk '{ print  NF }' | sort | head -1`) 
 if [ $nf -lt 4  ]  ; then 
  rm  *_${inx}* 
#  echo ${j} $inx $fon $nf `ls -l $fon` 
 fi 
 j=${j}+1
done

fold=`pwd | awk -F / '{ print $NF }' `
frq=`head  -1 ../movie/${fold}.dat | awk '{ print $9 }'` 
j=`echo "scale=0 ; int(${frq}*1000000)" | funcs.bc`
if [ ${j} -gt 0 ] ; then
 amp=0.5 ; ste=6
else
 amp=3 ; ste=20
fi

nsnap=(`ls snap*[0-9][0-9][0-9][0-9][0-9]*xyz  2> /dev/null | wc`)
nsna=${ste}+1
inx=`echo $fold | awk -F _ '{ print $2 }'`
ls snap.xyz || ln -s ../snap.xyz
ls vib_${inx}.dat || cp ../movie/vib_${inx}.dat . 

if [ ${nsnap} -lt ${nsna}  ] ; then
  rm snap*[0-9][0-9][0-9][0-9][0-9]*xyz run*xyz *[0-9][0-9][0-9][0-9][0-9]*inp 
  animate.bash -a ${amp} -n ${ste} -u -p vib_${inx}.dat -i snap.xyz 
  getlastxyz.bash -i run_${inx}.xyz -o snap -b
  jl=`ls snap_*xyz | sed 's/snap_// ; s/\.xyz//'` 
  if [ ${pim} -eq 1 ] ; then
   genjobpim.bash -l "${jl}" ${silent}
  else
   genjob.bash -l "${jl}" ${silent}
  fi
  if [ ${pim} -eq 1 ] ; then
   fibjob.bash
  else
   vibjob.bash
  fi
  ls nbearb > /dev/null 2> /dev/null || ln -s ~/bin/nbearb ;
fi

echo "fold: ${fold}, frq: ${frq}, j:${j}"

ndo=(`grep DONE *out | wc `)
nin=(`ls *inp 2> /dev/null | wc`) 

if [ ${ndo} -eq ${nin} ] ; then 
 :
else
 sbatch job*vib* 
fi 
