#!/bin/bash
# routine to

typeset -i i j fri

ifi=xas.out
genjob=false

while getopts i:j opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  j) genjob=true
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
export PATH=${PATH}:${SCRIPTPATH}

if $genjob ; then 
pstr=`pwd | awk -F / '{ print $NF }'`
echo "#!/bin/bash
#SBATCH --job-name="${pstr}_setup"
#SBATCH --nodes=1
#SBATCH --ntasks=1
#SBATCH --time=6:00:00
##SBATCH --mem-per-cpu=4GB
#SBATCH --partition=empi
#    User              Account  Partition 
#    dadams         grp_churakov       empi 
#    dadams                  geo      short 
#    dadams                  geo       empi 
#    dadams                  geo        all 

module load openmpi/1.10.2-intel
OMP_NUM_THREADS=\$SLURM_CPUS_PER_TASK
echo ~
dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"
${SCRIPT}
" > job_setup_vib.p
exit
fi

# cd mgo_cscl_0000_try/
akod=(`pwd | awk -F / '{ print $NF }'`)
 if ls coupling > /dev/null ; then 
  : 
 else 
  mkdir coupling 
  mv vib_[0-9][0-9][0-9][0-9] coupling.dat movie/* coupling/. 
 fi 
 cp ../eigenmodes/${akod}/vib* movie/. & 
 cp ../eigenmodes/${akod}/[a-s]* coupling/. &
 wait 
 cd movie 
  for fon in vib*dat ; do
   { str=`cat $fon` ;    echo "${str}" | sed 's/\r//' > $fon ; } &
  done
 cd ..
 wait 
 jl=(`ls movie/vib_*dat | sed 's/movie\/vib_// ; s/\.dat//'`)
 frq=(`grep cm movie/vib*dat | awk '{ print $9 }'`)
 j=0 ; jls=() ; jlu=()
 for fr in ${frq[*]} ; do
  fri=`echo "scale=0 ; int(${fr}*1000000)" | funcs.bc`
  if [ ${fri} -gt 0 ] ; then 
   jls=(${jls[*]} ${jl[${j}]})
  else
   jlu=(${jlu[*]} ${jl[${j}]})
  fi 
  j=${j}+1
 done
 echo ${jls[*]} 
 echo ${jlu[*]}
 ../bin/cre_vib.bash -l "${jlu[*]}" -a 3 -n 20 # unstable phonons
 ../bin/cre_vib.bash -l "${jls[*]}" -a 0.5 -n 6 # unstable phonons
exit

lastvibs=`ls -d vib_[0-9][0-9][0-9][0-9] | tail -5`
here=`pwd`
for fon in ${lastvibs} ; do
 cd $fon 
  sbatch job_*vib* 
 cd $here
done

 exit
 cd vib_0000/
 sbatch job_mgo_cscl_0000_try_vib_0000.p


exit

for n in ${lat} ; do
 echo ${j}
 j=${j}+1
done  
