#!/bin/bash
# routine to setup the vib_0000 vib_0001 ... folders
# jl=`ls movie/vib_*dat | sed 's/movie\/vib_// ; s/\.dat//'` 
# ../bin/cre_vib.bash -l "${jl}" -a 4 -n 40 # unstable phonons
# for fon in vib_00* ; do cd $fon; ./nbearb -n 1 ; cd ..; done

typeset -i i j k

inxl="0003"    # works also with a list of indices
amp=3       # amplitude (stable) phonons
ste=6          # number of steps for (stable) phonons
jof=short      # queue to submit to
psp="3:ppn=8" # processors per node
wtw="00:29:00" # expected running time of jobs 
pim=0

while getopts l:a:n:p opt
do
 case $opt in
  l) inxl="${OPTARG}"
  ;;
  a) amp="${OPTARG}"
  ;;
  n) ste="${OPTARG}"
  ;;
  p) pim=1 # active for cp2k structures
  ;;
 esac
done ; OPTIND=0

wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`
echo "inxl: ${inxl}"

SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
PATH=${SCRIPTPATH}:${PATH}

. integer_lib


#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "1.00666 0.0 0 \n 0.0 0.99669 0 \n 0  0 0.99669"  -p vib_.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "0.99669 0.0 0  \n 0.0 1.00666 0 \n 0  0 0.99669"  -p vib_9902.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "0.99669 0.0 0  \n 0.0 0.99669 0 \n 0  0 1.00666"  -p vib_9903.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "1.00336 0.100336 0  \n 0.100336 1.00336 0 \n 0  0 1.00336"  -p vib_9904.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "1.00336 0.0 0.100336  \n 0.0 1.00336 0 \n 0.100336  0 1.00336"  -p vib_9905.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "1.00336 0.0 0  \n 0.0 1.00336 0.100336 \n 0  0.100336 1.00336"  -p vib_9906.dat 
#./animate.bash -a ${amp} -n ${nstep} -u -i snap.xyz -e "1.01 0.0 0 \n 0.0 1.01 0 \n 0  0 1.01"  -p vib_9907.dat

dfstr=("1.00666 0.0 0 \n 0.0 0.99669 0 \n 0  0 0.99669" 
 "0.99669 0.0 0  \n 0.0 1.00666 0 \n 0  0 0.99669"
  "0.99669 0.0 0  \n 0.0 0.99669 0 \n 0  0 1.00666"  
"1.0000333355557  0.010000333355557 0  \n 0.010000333355557 1.0000333355557  0 \n 0 0 1.0000333355557"  
"1.0000333355557  0 0.010000333355557  \n 0 1.0000333355557  0 \n 0.010000333355557 0 1.0000333355557"  
"1.0000333355557  0 0  \n 0 1.0000333355557  0.010000333355557 \n 0 0.010000333355557 1.0000333355557"  
 "1.01 0.0 0 \n 0.0 1.01 0 \n 0  0 1.01" ) 
echo "${dfstr[1]}"

inxl="9901 9902 9903 9904 9905 9906 9907"
j=0
for inx  in $inxl ; do
 mkdir vib_${inx}
 lfi=(`ls vib_0000/snap.xyz snap.xyz shifts/vib_0000/snap.xyz`)
 ln -s  ../${lfi} vib_${inx}/snap.xyz
 cd vib_${inx}/
  animate.bash -a ${amp} -n ${ste} -u -p vib_${inx}.dat -i snap.xyz  -e "${dfstr[${j}]}"
  getlastxyz.bash -i run_${inx}.xyz -o snap -b
  jl=`ls snap_*xyz | sed 's/snap_// ; s/\.xyz//'` ;  
  if [ ${pim} -eq 1 ] ; then
   genjobpim.bash -l "${jl}" -q ${jof} -p ${psp} -w ${wtw}
  else 
   genjob.bash -l "${jl}" -q ${jof} -p ${psp} -w ${wtw}
  fi
  hinx=`piex -i ${inx}`
  k=${hinx}+1
  inx=`expi -i ${k} -l 4`
  recalcvib.bash
  if [ ${pim} -eq 1 ] ; then
   fibjob.bash
  else 
   vibjob.bash
   wibjob.bash
  fi  
  randir=`ls -d ../vib_*[0-9] | shuf | head -1`
  echo -e "cd ${randir} ; sbatch job_*vib_00* \n ./nbearb -n 1  \n " > list_job.txt
#  echo "cd ../vib_${inx}/ ; ./nbearb" >> list_job.txt
  ln -s ~/bin/nbearb ;  
  ls job*vib* | grep 6 && sbatch -l nodes=3:ppn=8 job_*vib* 
#  ./nbearb -n 1 
 cd ..
 j=j+1
done

