#!/bin/bash
# routine to setup the vib_0000 vib_0001 ... folders
# jl=`ls movie/vib_*dat | sed 's/movie\/vib_// ; s/\.dat//'`
# lisa=`ls -d vib_[0-9][0-9][0-9][0-9]  |  awk -F _ '{ print $2 }'`
# lisb=`ls -d movie/vib_[0-9][0-9][0-9][0-9].dat  | sed 's/\./_/g' |  awk -F _ '{ print $2 }'` 
# jl=`echo -e "$lisa\n${lisb}"  | sort | uniq -u`
# ../bin/cre_vib.bash -l "${jl}" -a 4 -n 40 # unstable phonons
# for fon in vib_00* ; do cd $fon; ./nbearb -n 1 ; cd ..; done

typeset -i i j k

inxl="0003"    # works also with a list of indices
amp=0.5        # amplitude (stable) phonons
ste=6          # number of steps for (stable) phonons
jof=short      # queue to submit to
psp="4:ppn=8"  # processors per node
wtw="00:29:00" # expected running time of jobs 
pim=0
ka=0           # offset for indexing of input files
off=0          # position offset
silent=""      

while getopts d:l:a:n:ps opt
do
 case $opt in
  l) inxl="${OPTARG}"
  ;;
  a) amp="${OPTARG}"
  ;;
  n) ste="${OPTARG}"
  ;;
  p) pim=1 # active for cp2k structures
  ;;
  d) off="${OPTARG}" # generate set out of equilibrum pos
  ;;
  s) silent="-s" # don't write individual job for each calculation, use job*vib* 
  ;;
 esac
done ; OPTIND=0

wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`
echo "inxl: ${inxl}"

SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
PATH=${SCRIPTPATH}:${PATH}

. integer_lib

for inx  in $inxl ; do
 ka=0 
 if ls -d vib_${inx}  ; then  
  : 
#  ka=(`ls vib_${inx}/snap*xyz`) # generate offset from existing files
#  ka=${#ka[*]}
#  mv vib_${inx} vib_${inx}.$$ 
# fi
 else
 mkdir vib_${inx}
 cp movie/vib_${inx}.dat vib_${inx}/. 
 lfi=(`ls vib_0000/snap.xyz snap.xyz shifts/vib_0000/snap.xyz`)
 ln -s  ../${lfi} vib_${inx}/snap.xyz
 cd vib_${inx}/
  animate.bash -a ${amp} -n ${ste} -u -p vib_${inx}.dat -i snap.xyz  -o ${ka} -d $off
  getlastxyz.bash -i run_${inx}.xyz -o snap -b
  jl=`ls snap_*xyz | sed 's/snap_// ; s/\.xyz//'` ;  
  if [ ${pim} -eq 1 ] ; then
   genjobpim.bash -l "${jl}" -q ${jof} -p ${psp} -w ${wtw} ${silent}
  else 
   genjob.bash -l "${jl}" -q ${jof} -p ${psp} -w ${wtw} ${silent}
  fi
#  hinx=`piex -i ${inx}`
#  k=${hinx}+1
#  inx=`expi -i ${k} -l 4`
 # recalcvib.bash
  if [ ${pim} -eq 1 ] ; then
   fibjob.bash
  else 
   vibjob.bash
   wibjob.bash
  fi  
  randir=`ls -d ../vib_*[0-9] | shuf | head -1`
  echo -e "cd ${randir} ; sbatch  job_*vib_00* \n ./nbearb -n 1  \n " > list_job.txt
#  echo "cd ../vib_${inx}/ ; ./nbearb" >> list_job.txt
  ln -s ~/bin/nbearb ;  
  ls job*vib* | grep 6 && sbatch -l nodes=2:ppn=8 job_*vib* 
#  ./nbearb -n 1 
 cd ..
 fi 
# if ls -d vib_${inx}.$$  ; then 
#  mv vib_${inx}.$$ vib_${inx}/. 
#  rm -r vib_${inx}.$$
# fi
done
