#!/bin/bash
# routine to draw arrows
# USAGE : draw_arrows_snap.bash -i start.xyz -p stop.xyz -o arrow.vmd
# USAGE: generates files file arrow.vmd indicating ionic movement between initial and final geometry

typeset -i i j k

ifi=start.xyz # input file initial geometry
pfi=stop.xyz # input file  final geometry
ofi=arrow.vmd
fak=3

while getopts i:p:o:f: opt
do
 case $opt in
  i) pfi="${OPTARG}"
  ;;
  p) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
  f) fak="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib

lat="1 2 4"

j=1
str=`cat ${ifi}`
hstr=""
hfak=`echo "scale=8 ; int(${fak}/3*2)" | funcs.bc` #define minimal length for drawing of arrows
while read lin ; do
 if [ ${j} -le 2 ] ; then
  : 
 else 
  c=(${lin})
  d=(`echo "${str}" | sed -n "${j}p"`)
  k=1 ; del=0
  for el in ${c[1]} ${c[2]} ${c[3]} ; do
   del="${del}+((${el})-(${d[${k}]}))*((${el})-(${d[${k}]}))"
   d[${k}]=`echo "scale=5 ; (${d[${k}]})+(${fak})*(${el}-(${d[${k}]}))" | bc`
   k=${k}+1
  done
  echo "c: ${c[*]}, d: ${d[*]} "
  len=`echo "scale=8 ; ${del}" | bc`
  ilen=`echo "scale=8 ; int(${len}*10)" | funcs.bc`
  echo "len: ${len}, ilen: ${ilen}"
  if [ ${ilen} -ge ${hfak} ] ; then # draw only arrows with a certain length
   hstr="${hstr} \\n arrow { ${c[1]} ${c[2]} ${c[3]} } { ${d[1]}  ${d[2]} ${d[3]} }"
  fi
 fi
j=j+1
done < ${pfi}
 
hstr=`echo -e "${hstr}"`

echo "proc arrow { start end } {" > ${ofi}
while read lin ; do
echo "${lin}" >> ${ofi}
done << EOF 
    # an arrow is made of a cylinder and a cone
    set middle [vecadd \$start [vecscale 0.9 [vecsub \$end \$start]]]
    graphics top cylinder \$start \$middle radius 0.05
    graphics top cone \$middle \$end radius 0.10 
}
${hstr}

EOF

exit
