#!/bin/bash
# routine to

typeset -i i j

ifi=naliz.dat
ampl=0.0001
workf=naliz.dat
ll=1.5

while getopts i:a:l: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  a) ampl="${OPTARG}"
  ;;
  l) ll="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
export PATH=${PATH}:${SCRIPTPATH}
sstr=`cat $ifi`
pi=$(echo "scale=10; 4*a(1)" | bc -l)

lat="1 2 4"

j=1
cp ${ifi} .hef.$$
for phas in  1 2 3 0 -1 -2 -3 ; do
 hj=`expi -i $j`
 rm $workf
 while read lin ; do 
  if [[ ${lin} !=  "#"* ]] ;  then 
   c=(${lin[*]})
  # te=`echo "abs(${c[0]})<0.5" | funcs.bc`
  #c[2]=`echo "scale=8 ; ${c[2]}+${c[0]}*e(-abs(${c[0]})/${ll})*(${phas})*(${ampl})" | funcs.bc`
  #   c[2]=`echo "scale=8 ; ${c[2]}+sgn(${c[0]})*(${phas})*(${ampl})" | funcs.bc`

    echo "${c[*]}" >> $workf
  else
   echo "${lin}" >> $workf
  fi
 done < .hef.$$
 c[2]=`echo "scale=8 ; (${phas})*(${ampl})" | funcs.bc`
echo "#vpert ${c[2]}" >> $workf
eigenstates.x > eigenstates${hj}.log
mv eigenstates.dat eigenstates${hj}.dat 
mv eigenvecs.dat eigenvecs${hj}.dat
mv fit.dat fit${hj}.dat
mv ${workf} naliz${hj}.dat

ofi=naliz${hj}
while read lin ; do
echo ${lin} >> ${ofi}.xmgr
done << EOF
# xmgrace -hardcopy  -noask -noprint -nosafe -batch ${ofi}.xmgr 
title "V(f) ${here}"
focus g0
s0 symbol 2
s0 symbol size 0.560000
s0 symbol color 1 
s0 symbol pattern 1
s0 symbol fill color 2 
s0 symbol fill pattern 1
s0 symbol linewidth 1.0
s0 symbol linestyle 1
s0 symbol char 0
s0 symbol char font 4
s0 symbol skip 0
read block "${ofi}.dat" 
block xy "1:3"
push
focus g1
s1 line linestyle 2
s1 symbol type 2
read block "fit${hj}.dat"
block xy "2:3"
pop
#s0 legend "up"
yaxis label "E [Ry]"
xaxis label "f [a.u.]"
autoticks
print to "${ofi}.svg"
hardcopy device "SVG"
print
print to "${ofi}.png"
hardcopy device "PNG"
print 
s1.y=s1.y-min(s0.y)
s0.y=s0.y-min(s0.y)
world xmin -1
world xmax 1
world ymax 0.1
world ymin -0.01
autoticks
print to "${ofi}_zoom.svg"
hardcopy device "SVG"
print to "${ofi}_zoom.png"
hardcopy device "PNG"
print
exit
EOF
 j=${j}+1
done

#cat $workf
echo "${sstr}" > $ifi
.hef.$$
