#!/bin/bash
# routine to

typeset -i i j

ifi=xas.out
jof=infiniband    # queue to submit to
psp="1:ppn=4" # processors per node
wtw="00:29:00" # expected running time 


while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
lat="1 2 4"
wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`


cat > job_fib.p << EOF
#PBS -N ${wai}_fib
#PBS -l walltime=${wtw} 
#PBS -q ${jof}
#PBS -l nodes=${psp}
#PBS -j oe
ulimit -s unlimited
PATH=~/bin:/share/apps/espresso/espresso-5.0.3/bin:/home/apps/bin:\${PATH}:`dirname \$(readlink -f \$0)`
ulimit -s unlimited
module unload openmpi
module load mvapich2
module load  cp2k/2.6
cd \$PBS_O_WORKDIR
NSLOTS=\`cat \$PBS_NODEFILE | wc -l | awk '{ print \$1 }'\` ; dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"

inpl=(\`ls *.inp | sed 's/\.inp//g'\`)

for fan in \${inpl[*]} ; do
 export INP=\${fan}
 if grep "PROGRAM ENDED AT" \$INP.out ; then
  :
 else 
  mv \$INP.out.bak-2 \$INP.out.bak-3 ; mv \$INP.out.bak-1 \$INP.out.bak-2 ; mv \$INP.out \$INP.out.bak-1
  mpiexec -np \${NSLOTS}  cp2k.popt -i \$INP.inp > \$INP.out  
 fi
done
opl=(\`ls *.out | sed 's/\.out//g'\`)
[ \${#opl[*]} -eq \${#inpl[*]} ] && [ \${#inpl[*]} -gt 0 ] &&  resubmitpim.bash
./nbearb -n 1
EOF

exit 

j=0
for n in ${lat} ; do
 echo ${j}
 j=${j}+1
done

