#!/bin/bash
# routine to

typeset -i i j

ifi=xas.out
qpt=2

while getopts i:q: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  q) qpt="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib

lat="1 2 3 4 5 6 7 8 9 10 11 12 f"
hqpt=`expi -i ${qpt} -l 2`
#mkdir qpt${hqpt}
#cp -r cryo.dyn0 _* PH.save qpt${hqpt}/. 
cd qpt${hqpt} 
jn=`pwd  | awk -F / '{  print $(NF-1)"_"$NF }'`
j=0
ln -s ~/bin/nbearb
for n in ${lat} ; do
 hn=`expi -i $n -l 2`
 cat > job${hn}.p << EOFF
#PBS -N ${jn}${hn}
#PBS -l walltime=23:59:59
#PBS -l nodes=1:ppn=8
#PBS -q infiniband    
#PBS -j oe
ulimit -s unlimited
typeset -i n  k j i m q 
export PATH=/share/apps/espresso/espresso-5.0.3/bin:~/bin:\$PATH
module load mvapich2
which pw.x ph.x  mpiexec
cd \$PBS_O_WORKDIR
NSLOTS=\`cat \$PBS_NODEFILE | wc -l | awk '{ print \$1 }'\` ; dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"
export RN=cryo
export INP=\${RN}.scf

hstr=\`sed -n '/ATOMIC_SPECIES/,/ATOMIC_POSITIONS/{/ATOM/d ; p; } ' \${RN}.scf.inp  | awk '{ print "amass("NR")=  "\$2"," }'\`

nq1=6 ;nq2=6 ; nq3=4

echo "n: \${n} q: \${q}"
cat > \${RN}.ph.inp << EOF
phonons of \${RN}
 &inputph
  tr2_ph=1.0d-14,
  ldisp=.true.,
  recover=.true.,
  nq1=\${nq1}, nq2=\${nq2}, nq3=\${nq3},
  start_irr =${n},
  last_irr =${n},
  start_q = ${qpt},
  last_q= ${qpt},
  \${hstr} 
  prefix='PH',
  outdir='./'
  fildyn='\${RN}.dyn',
 / 
EOF
 export INP=\${RN}.ph
 mv \$INP.out.bak-2 \$INP.out.bak-3 ; mv \$INP.out.bak-1 \$INP.out.bak-2 ; mv \$INP.out \$INP.out.bak-1
 rm *wfc* *igk* _ph0/*igk*  _ph0/*dwf* _ph0/*bar* _ph0/*recov* _ph0/*prd* _ph0/*wfc* _ph0/K*
 mpiexec -np \${NSLOTS} ph.x < ./\$INP.inp > \$INP.out
 date ; ./nbearb -n 1 
EOFF
 [ "${n}" == "f" ] && str=`sed '/_irr/d' job${hn}.p` && echo "${str}" > job${hn}.p
 str=`sed "/job${hn}/d; /^$/d" list_job.txt`
 echo -e "${str}\n sbatch job${hn}.p" > list_job.txt
 echo ${j}
 j=${j}+1
done
 ./nbearb -n 1 
cd ..
