#!/bin/bash
# routine to
# jl=`ls snap_*xyz | sed 's/snap_// ; s/\.xyz//'`
# ./genjob.bash -l "${jl}"

typeset -i i j

#inxl="000000" # works also with a list of indices
inxl=`ls snap_*xyz | sed 's/snap_// ; s/\.xyz//'` 
jof=short # queue to submit to
psp="2:ppn=8"
wtw="02:00:00"
silent=true

while getopts l:q:p:w:s opt
do
 case $opt in
  l) inxl="${OPTARG}"
  ;;
  q) jof="${OPTARG}"
  ;;
  p) psp="${OPTARG}"
  ;;
  w) wtw="${OPTARG}"
  ;;
  s) silent=true
  ;;
 esac
done ; OPTIND=0

wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`

cat > .hef.$$ << EOF
#PBS -N ${wai}_NUMM
#PBS -l walltime=WTW 
#PBS -q JOFF
#PBS -l nodes=PSP
#PBS -j oe
ulimit -s unlimited
PATH=~/bin:/share/apps/espresso/espresso-5.0.3/bin:/home/apps/bin:\${PATH}:\`dirname \$(readlink -f \$0)\`
module load mvapich2
cd \$PBS_O_WORKDIR
NSLOTS=\`cat \$PBS_NODEFILE | wc -l | awk '{ print \$1 }'\` ; dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"
export INP=${wai}_NUMM
if ls \${INP}.wfc* ; then
 sed "/restart_mode/c\\
restart_mode=\'restart\'
" \$INP.inp > .hef.\$$
mv .hef.\$$ \$INP.inp
fi 
if grep "convergence has been achieved" \$INP.out ; then
 rm -r \$INP.*igk* \$INP*wfc* \$INP*save 
else 
 mv \$INP.out.bak-2 \$INP.out.bak-3 ; mv \$INP.out.bak-1 \$INP.out.bak-2 ; mv \$INP.out \$INP.out.bak-1
 mpiexec -np \${NSLOTS}  pw.x  -npools 2 < ./\$INP.inp > \$INP.out
 if $silent ; then
  rm -r \${INP}.save
 else 
  tar -czf \${INP}.save.tar.gz \${INP}.save && rm -r \${INP}.save 
 fi 
fi
./nbearb -n 1 
EOF


ifi=../cryo.vib.inp 
ifi=../cryo.scf.inp
hifi=`sed "s/'relax'/'scf'/ ; /ATOMIC_POSITI/q ; /K_POINT/q ; /CELL_/q" ${ifi} | sed '/K_POINT/d ; /CELL_/d ; /ATOMIC_POSITI/d'`
tifi=`sed -n "/K_POINTS /,$ p ; " ${ifi}| sed '/ATOMIC_POS/q ; /CELL_/q ;'| sed '/ATOMIC_POS/d ; /CELL_/d ;'` #  '
cifi=`sed -n "/CELL_PARAMETERS/,$ p ; " ${ifi}| sed '/ATOMIC_POS/q ; /K_POINTS/q ;'| sed '/ATOMIC_POS/d; /POINTS/d;'` # 

echo "hifi: ${hifi} tifi: ${tifi} cifi: ${cifi} inxl: ${inxl}" 

for fon in $inxl ; do
 if ls ${wai}_${fon}.inp > /dev/null 2> /dev/null ; then 
  : 
 else
  pstr=`sed 1,2d snap_${fon}.xyz`
  echo -e "${hifi} \n ATOMIC_POSITIONS  angstrom \n ${pstr} \n ${tifi} \n${cifi}" | sed "/prefix/c\
\ prefix='${wai}_${fon}'
   " > ${wai}_${fon}.inp #cryolite_ht_000000.scf.inp 
  if $silent ; then
    rm snap_${fon}.xyz  
  else
   rm list_job.txt  
   sed "s/NUMM/$fon/g ; s/JOFF/${jof}/ ; s/PSP/${psp}/; s/WTW/${wtw}/ ; " .hef.$$ > job_${wai}_${fon}.p 
   echo "sbatch job_${wai}_${fon}.p" >> list_job.txt
  fi
 fi 
done
rm .hef.$$ .hhef.$$

exit 
 for fon in job_${wai}*.p ; do
  :
# sbatch $fon
# sleep 2
 done 
