#!/bin/bash
# routine to
# jl=`ls vib*dat | sed 's/vib_// ; s/\.dat//'`
# ../../movie/genjob.bash -l "${jl}"

typeset -i i j

inxl="0010" # works also with a list of indices

while getopts l: opt
do
 case $opt in
  l) inxl="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`

cat > .hef.$$ << EOF
#PBS -N movie_${wai}_NUMM
#PBS -l walltime=00:05:00 
#PBS -q infiniband
#PBS -j oe
ulimit -s unlimited
PATH=${PATH}:`dirname $(readlink -f $0)`
cd \$PBS_O_WORKDIR ; animate.bash -a 2 -n 60 -u -p vib_NUMM.dat -i snap.xyz 
rm movie_${wai}_*.o[0-9]*
EOF

for fon in $inxl ; do
 sed "s/NUMM/$fon/g" .hef.$$ > .hhef.$$
 sbatch .hhef.$$
done
rm .hef.$$ .hhef.$$
