#!/bin/bash
# routine to

typeset -i i j k l h

ifi=xas.out
ofi=coupling.dat
silt=false

while getopts i:s opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  s) silt=true # silent mode
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
export PATH=${PATH}:${SCRIPTPATH}
lat="1 2 4"

echo $silt

h=0  ; i=0
here=`pwd` ; echo "# "`pwd`" force constants in Ry/a0*m_e/Angst" > $ofi
for fon in vib_[0-9][0-9][0-9][0-9]  ; do 
 cd $fon
 ${silt} ||  pwd
 hh=`echo $fon | awk -F _ '{ print $2 }'`
 j=0
 c=(`grep "  force =" *_[0-9][0-9][0-9][0-9]*001.out | awk -F "force =" '{ print $2 }'`)
 d=(`grep "  force =" *_[0-9][0-9][0-9][0-9]*003.out  | awk -F "force =" '{ print $2 }'`)
 #echo "c:  ${c[*]}"
 #echo "d:  ${d[*]}"
 subs=`sed -n '/ATOMIC_SPECIES/,/_[A-Z]/{ /UPF/p ; }' *_[0-9][0-9][0-9][0-9]*001.inp | awk '{ print "s/"$1"/"$2"/g;" }'`
 mc=(`sed -n '/ATOMIC_POSITIONS/,/_[A-Z]/{ /[0-9]/p ; }' *_[0-9][0-9][0-9][0-9]*001.inp | awk '{ print $1 }' | sed "${subs}"`)
# echo "subs: ${subs}"
 echo "mc: ${mc[*]}"
 amp=`grep uc *_[0-9][0-9][0-9][0-9]*001.xyz | awk '{ print $1 }'`
 j=0 ; k=0 ; cc=(${c[*]})
 for co in ${c[*]}  ; do
  echo  "l: ${l} k:${k} j: ${j} ((${d[${j}]})-(${c[${j}]}))/(2*sqrt(${mc[${k}]}*${mc[${h}]}*(${amp})*(${amp})))"     
  cc[${j}]=`echo "scale=10 ; ((${d[${j}]})-(${c[${j}]}))/(2*sqrt(${mc[${k}]}*${mc[${h}]}*(${amp})*(${amp})))" | bc -l`
  l=(${j}+1)%3 ;  [ ${l} -eq 0 ] && k=${k}+1 
  j=${j}+1
  # [ ${j} -gt 44 ] && exit
 done
 de=(`sed '/mass/d' vib*.dat `)
 cd $here
 echo "${hh} kk ${cc[*]}" >> $ofi
 echo "${hh} de ${de[*]}" >> $ofi
 l=(${i}+1)%3 ;  [ ${l} -eq 0 ] && h=${h}+1 
 i=${i}+1
# [ $i -gt 3 ] && exit
done
