#!/bin/bash
# Routine to generate xyz-file containing coordinates of last interation 
# USAGE:  getlastxyz -i run.xyz -o snap.xyz 

typeset -i i j k m n

ifi=dft_md_eq-pos-1.xyz 
ofi=snap
tim="" ; ste=""
brs=false

while getopts l:i:o:t:s:b opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
  s) ste="${OPTARG}"
  ;;
  l) lst="${OPTARG}" # get the last $lst steps
  ;;
  b) brs=true ; ste=b #burst md trajectorie
  ;; 
 esac
done

. integer_lib

ls ${ifi} > /dev/null 2> /dev/null || { echo "${ifi} not exisiting, getlastxyz exiting" ; exit ; }

c=(`sed -n '/E/='  ${ifi} ` `wc ${ifi} | awk '{ print $1 }'`)
str=`sed -n '/E/{s/,/ /g ;p;} '  ${ifi} `
ic=(`echo "${str}" | awk '{ print $3 }'`)
tc=(`echo "${str}" | awk '{ print $6 }'`)
m=${#c[*]}-1 # number of steps in ${ifi} 
[[ "${lst}" == "" ]] && lst=${m}
k=${m} ; j=${c[${k}]}+2
c[${k}]=${j}

#echo echo "m: ${m}, c[m-1]: ${c[${k}]}, n: ${n}, ste: ${ste} , ic[${n}]: ${ic[${n}]} "
n=0
 
if [[ "${ste}" == "" ]] ; then
 n=${m}-1
elif ${brs} ; then
 n=${m}-${lst} 
 hj=_`expi -i ${ic[${n}]} -l 14 `
else
 while [ ${n} -lt ${m} ] && [ ${ic[${n}]} -lt ${ste} ] ; do
  n=${n}+1
 done
fi

#echo echo "brs: ${brs} m: ${m}, c[m-1]: ${c[${k}]}, n: ${n}, ste: ${ste} , ic[${n}]: ${ic[${n}]} "
tstr=`cat ${ifi}`
while [ ${n} -lt ${m} ] ; do
 i=${c[${n}]}-1
 n=${n}+1
 j=${c[${n}]}-2
 hjn=${hj}
 for zi in a b c d e f g h i j k l m n ; do
  ls ${ofi}${hjn}.xyz > /dev/null 2> /dev/null || break
  hjn=${hj}${zi}
 done
 echo "${tstr}" | sed -n "${i},${j}p" > ${ofi}${hjn}.xyz
 ${brs} || exit
 hj=_`expi -i ${ic[${n}]} -l 14`
# exit
done
