#!/bin/bash
# routine to list all states belonging to a choice of atoms
# example list_sublattice.dat file:
#A 30 24 27 29   3 9 13 14   4 0 6 10  17 15 18   22 20  
#B 25 23 26 28   5 1  7 11   2 8 12    16 19      21
# run getallstates.bash -s B 

typeset -i i j k ks

ifi=mmag_pwscf_0003_proj.out
lfi=list_sublattice.dat
sl=A 

while getopts i:l:s: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  l) lfi="${OPTARG}"
  ;;
  s) sl="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. string_lib

al=(`grep ${sl} $lfi`)

stl=()
for hk in ${al[*]} ; do
 if [ "${hk//[0-9]*}" = "" ] ; then
  i=${hk}+1
  hj=`exst -i "${i}" `
  stl=(${stl[*]} `sed -n "/atom${hj}/{ s/:/ /g ; p ; }" ${ifi} | awk '{ print $3 }'`)
  #echo "i: ${hj} stl: ${stl[*]}"
 fi
done
echo "stl: ${stl[*]}"

exit
grep "state #" ${ifi}

exit

A 30 24 27 29   3 9 13 14   4 0 6 10  17 15 18   22 20  
B 25 23 26 28   5 1  7 11   2 8 12    16 19      21

 state # 108: atom  27 (C  ), wfc  2 (l=1 m= 3)
     state # 109: atom  28 (C  ), wfc  1 (l=0 m= 1)
     state # 110: atom  28 (C  ), wfc  2 (l=1 m= 1)
     state # 111: atom  28 (C  ), wfc  2 (l=1 m= 2)
     state # 112: atom  28 (C  ), wfc  2 (l=1 m= 3)
     state # 113: atom  29 (C  ), wfc  1 (l=0 m= 1)
     state # 114: atom  29 (C  ), wfc  2 (l=1 m= 1)
     state # 115: atom  29 (C  ), wfc  2 (l=1 m= 2)
     state # 116: atom  29 (C  ), wfc  2 (l=1 m= 3)
     state # 117: atom  30 (C  ), wfc  1 (l=0 m= 1)
     state # 118: atom  30 (C  ), wfc  2 (l=1 m= 1)
