#!/bin/bash
#USAGE: graph_conv.bash -k "Total energy:" -p 3 -i dftb_opt_145.out # cp2k-dftb
#USAGE: graph_conv.bash -k "!    total energy" -p 5 -i  opt_145.out    #  pwscf-relax dft
#USAGE: graph_conv.bash -k E -p 6 -i  dftb_opt_110-pos-1.xyz 

typeset -i i j m
ifi=xas_0018.out
kw=Broy 
pos=6
ver=true 
lg=true

while getopts i:k:p:sl opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  k) kw="${OPTARG}"
  ;;
  p) pos="${OPTARG}"
  ;;
  s) ver=false # verbos: show graph 
  ;; 
  l) lg=false # if put: do not calculate logarythmic convergence
  ;;
 esac
done
ofi=`echo $ifi | sed 's/\.out/.conv/ '`
ls ${ifi} > /dev/null 2> /dev/null || { echo "${ifi}  does not exist" ; exit ; } 

. integer_lib

sed -n "/${kw}/p" ${ifi} | awk "{ print FNR \"\t\" \$${pos}    }" > .hefi.$$
#cat .hefi.$$
#rm .hefi.$$
#exit
rd=(`tail -1 .hefi.$$`)
if ${lg} ; then
 sed '/eV/d' ${ifi} | awk -v re=${rd[1]} '{ print $1" "log(sqrt(($2-re)*($2-(re))))/log(10) }' .hefi.$$ | sed '/[a-zA-Z]/d' > ${ofi}.$$.dat 
else
 sed '/^#/d ; /eV/d' ${ifi} | awk -v re=${rd[1]} '{ print $1" "$2 }' .hefi.$$ | sed '/[a-zA-Z]/d' > ${ofi}.$$.dat
fi
#tail ${ofi}.$$.dat

cat > ${ofi}.$$.xmgr << EOF
#xmgrace -batch ${ofi}.$$.xmgr -nosafe 
s0 line color 2
title "${ifi}: ${rd[1]}"
s0 legend "convergence"
focus g1
read block "${ofi}.$$.dat"
block xy "1:2"
yaxis label "log_10[dE]"
autoscale yaxes
autoticks
hardcopy device "SVG"
print to "${ofi}.svg"
print
exit
EOF
ls ${ofi}.svg 2> /dev/null && rm ${ofi}.svg
xmgrace -batch ${ofi}.$$.xmgr -nosafe 
${ver}  && display ${ofi}.svg & 

rm ${ofi}.$$.*

exit
