#!/bin/bash
# routine to

typeset -i i j

ifi=cryo.dos
sig=20

while getopts i:s: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  s) sig="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib
#lat="1 2 4"
#j=0
#for n in ${lat} ; do
# echo ${j}
# j=${j}+1
#done

awk ' { print NR  " " $1 " " $2 }' $ifi > ${ifi}.conv 
sed '/min/d ' glnaliz.dat | awk ' { print NR  " " $5 " " 1 }'  > filder.conv 
# sed '/min/d ' glnaliz.dat | awk ' { print NR+57  " " $6 " " 1 }'  >> filder.conv  
sed '/min/d ' glnaliz.dat | awk ' { print NR  " " $7 " " 1 }'  > filher.conv


rm smear.log >  /dev/null  2> /dev/null
my_convolute.x -smin ${sig}  -smax ${sig} -fin ${ifi}.conv -fout .hef.$$ -de 1 -ncol 1   >> smear.log 2>> smear.log ; mv .hef.$$ ${ifi}.conv
my_convolute.x -smin ${sig}  -smax ${sig} -fin filher.conv -fout .hef.$$ -de 1 -ncol 1   >> smear.log 2>> smear.log ; mv .hef.$$ filher.conv
my_convolute.x -smin ${sig}  -smax ${sig} -fin filder.conv -fout .hef.$$ -de 1 -ncol 1   >> smear.log 2>> smear.log ; mv .hef.$$ filder.conv

cat > ${ifi}.conv.xmgr << EOF
# xmgrace -nosafe -batch ${ifi}.conv.xmgr
title "Phonon DOS"
focus g0
focus g0
read block "${ifi}.conv"
block xy "2:1"
s0.x = s0.x / int(s0.y,s0.x)
read block "filher.conv"
block xy "2:1"
s1.x = s1.x / int(s1.y,s1.x)
read block "filder.conv"
block xy "2:1"
s2.x = s2.x / int(s2.y,s2.x)  
yaxis label  "\x  w  \0 [cm-1]"
xaxis label "DOS [a.u.]"
S0  line color 1
S0  legend "pwscf/cp2k"
S1  line color 2
S1  legend "dos (2nd deriv)"
S2  line color 3
S2  legend "dos (full)"
autoticks
autoscale
print to "${ifi}.conv.svg"
hardcopy device "SVG"
print
print to "${ifi}.conv.eps"
hardcopy device "EPS"
print
exit
EOF

rm ${ifi}.conv*eps ${ifi}.conv*svg 
xmgrace -nosafe -batch ${ifi}.conv.xmgr  
display ${ifi}.conv.eps
