#!/bin/bash
# routine to fit murnaghan EOS to pressure data
# provide data, so that minimal absolute pressures are in first lines

typeset -i i j

ifi=maliz.datpress # maliz obtained from  ~/bin_opt/allubers.bash -v p -i press
prec=10; 
pv0=0 # volume
pb0=0 # bulk modulus
pbs=0 # b0'
pe0=0 # ground state energy

while getopts i:v:b:s:e: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  v) pv0="${OPTARG}"
  ;;
  b) pb0="${OPTARG}"
  ;;
  s) pbs="${OPTARG}"
  ;;
  e) pe0="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
export PATH=${PATH}:${SCRIPTPATH}
pv=() ; 
lvv=() ; vv=()
while read lin ; do
#press_1500/run_optc optc_pwscf_001 -721.17895905 1500.19 896.1999 -712.0406006544 10 -5.118
 echo $lin | grep nam > /dev/null && continue
 c=(${lin})
 pv=(${pv[*]} ${c[3]})
 vv=(${vv[*]} ${c[4]})
 hv=`echo "scale=${prec} ; l(${c[4]})" | bc -l`
 lvv=(${lvv[*]} ${hv})
 # echo $lin  
done < $ifi
#echo "${pv[*]} ${lvv[*]}"
cf=(`linearfit.bash -x "${pv[0]} ${pv[1]}" -y "${lvv[0]} ${lvv[1]}" -p ${prec}`)
#echo "cf: ${cf[*]}"
v0=`echo "scale=${prec} ; e(${cf[0]})" | bc -l`
b0=`echo "scale=${prec} ; (-1)/(${cf[1]})" | bc -l`
#echo "vo: ${v0}, b0: ${b0}"
llvv=() ; i=0 ; ph=()
for el in ${vv[*]} ; do
 if [ ${i} -gt 0 ] ; then 
  j=${i}-1
  hv=`echo "scale=${prec} ; l(${vv[${i}]}/${v0})" | bc -l`
  ph=(${ph[*]} "${hv}")
  if [ "${pv[${i}]}" == "${pv[${j}]}" ] ; then 
   :
  else
   hv=`echo "scale=${prec} ; l(-(${vv[${i}]}-${vv[${j}]})/((${pv[${i}]})-(${pv[${j}]})))" | bc -l`
  fi
 # echo "vo: ${v0}, hv: ${hv}, l(-(${vv[${i}]}-${vv[${j}]})/((${pv[${i}]})-(${pv[${j}]})))"
  llvv=(${llvv[*]} $hv)
 fi
 i=${i}+1
done
#echo "ph: ${ph[*]} " -y "${llvv[*]}"
cf=(`linearfit.bash -x "${ph[*]} " -y "${llvv[*]}" -p ${prec}`)
#echo "cf: ${cf[*]}"
bs=`echo "scale=${prec} ; ${cf[1]}-1" | bc -l`
#b0=`echo "scale=${prec} ; e(${cf[1]})*${v0}/10" | bc -l`
echo "#nam en[Ry] p[kbar] vol[a.u.^3] H[Ry]  nstep log(dE)/ v0: ${v0} [(a.u.)^3], b0: ${b0} [kbar] bs: ${bs} [1]" > .hef.$$
[ "${pv0}" == "0" ] && pv0=${v0}
[ "${pb0}" == "0" ] && pb0=${b0}
[ "${pbs}" == "0" ] && pbs=${bs}
#[ ${pe0} -eq 0 ] && pe0=${e0}
while read lin ; do
#press_1500/run_optc optc_pwscf_001 -721.17895905 1500.19 896.1999 -712.0406006544 10 -5.118
 echo $lin | grep nam > /dev/null && continue
 c=(${lin})
# echo "scale=${prec} ; ${pb0}*${pv0}/(${pbs}-1)*(pow(${pbs}/${pb0}*(${c[2]})+1,1-1/${pbs})-1)"
 hv=`echo "scale=${prec} ; ${pb0}*${pv0}/(${pbs}-1)*(pow(${pbs}/${pb0}*(${c[3]})+1,1-1/${pbs})-1)*0.00000679786" | funcs.bc `
 c[8]=`echo "scale=${prec} ; ((${c[5]})-(${hv})-(${pe0}))*13.60569193" | bc `
 echo ${c[*]} >> .hef.$$ 
done < $ifi
mv .hef.$$ $ifi
echo "#nam  v0: ${pv0} [(a.u.)^3], b0: ${pb0} [kbar] bs: ${pbs} [1] e0: ${pe0} [Ry]" >> $ifi
cat $ifi

exit

