#!/bin/bash
# routine to

typeset -i i j

lat="40 45 50 55"
dirn=`pwd | awk -F / '{ print $NF }'` 
qu=infinijazz
nd=4
pn=4


while getopts l:q:n:p: opt
do
 case $opt in
  l) lat="${OPTARG}"
  ;;
  q) qu="${OPTARG}"
  ;;
  n) nd="${OPTARG}"
  ;;
  p) pn="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib

str=`while read lin ; do
 echo "${lin}"
done << EOF
#PBS -N ${dirn}_dftb_opt
#PBS -l walltime=00:59:00
#PBS -l nodes=${nd}:ppn=${pn}
#PBS -q ${qu}
#PBS -j oe 
ulimit -s unlimited
export LD_LIBRARY_PATH=/home/libs/mkl/lib_11:"\\$LD_LIBRARY_PATH" ; export INP=dftb_opt 
cd \\$PBS_O_WORKDIR
NSLOTS=£cat \\$PBS_NODEFILE | wc -l | awk '{ print \\$1 }'£ ; dstr=£date£
echo "HOSTNAME: \\${HOSTNAME} PBS_JOBNAME: \\${PBS_JOBNAME} PBS_JOBID: \\${PBS_JOBID} date: \\${dstr}"
mv \\$INP.out.bak-2 \\$INP.out.bak-3 ; mv \\$INP.out.bak-1 \\$INP.out.bak-2 ; mv \\$INP.out \\$INP.out.bak-1
mpiexec -np \\$NSLOTS /home/apps/bin/cp2k_11 -i ./\\$INP.inp -o \\$INP.out ; date ; 
ls -d run_dftb || mkdir run_dftb ; 
getlastxyz -i dftb_opt-pos-1.xyz -o snap 
rm \*.wfn.bak\* \*.restart.bak\* ; mv dftb_opt.inp dftb_opt.out dftb_opt-pos-1.xyz job_dftb_opt.p run_dftb/. ; rm \*dftb_opt\* 
./nbearb
EOF
`
while read lin ; do
echo "${lin}" >> .hef.$$
done << EOF
&FORCE_EVAL
\  &DFT
\    LSD
\#   MULTIPLICITY 21
\    &QS
\      METHOD DFTB
\      &DFTB
\        SELF_CONSISTENT    T
\        DISPERSION         T
\        ORTHOGONAL_BASIS   F   
\        DO_EWALD           F
\	HB_SR_GAMMA        T
\        &PARAMETER
\          PARAM_FILE_PATH  /home/adj127/cp2kbasis/scc
\          PARAM_FILE_NAME  scc_parameter
\          UFF_FORCE_FIELD  ./uff_table
\        &END PARAMETER
\      &END DFTB
\    &END QS
\    &SCF
\      SCF_GUESS ATOMIC 
\      MAX_SCF  30
\      EPS_SCF 1.0E-6
\      &OT ON
\        PRECONDITIONER NONE
\      &END OT
\      &OUTER_SCF 
\	MAX_SCF 20
\        EPS_SCF 1.0E-6
\      &END
\  &END SCF
\
\  &END DFT
\  &SUBSYS
\    &CELL 
\    ABC  15 50 50 
\    &END CELL
\    &TOPOLOGY
\      COORD_FILE_NAME ./snap.xyz 
\      COORDINATE xyz
\    &END
\  &END SUBSYS
&END FORCE_EVAL
\
&GLOBAL
\  PRINT_LEVEL MEDIUM
\  PROJECT dftb_opt 
\  RUN_TYPE GEO_OPT 
&END GLOBAL
\
&MOTION
\  &GEO_OPT
\   MAX_ITER 150
\   RMS_FORCE 5.E-03 
\  &END GEO_OPT
\  &PRINT
\    &TRAJECTORY
\      FORMAT XYZ
\      &EACH
\        GEO_OPT 10
\      &END EACH
\      ADD_LAST NUMERIC
\    &END TRAJECTORY
\    &RESTART_HISTORY OFF
\    &END RESTART_HISTORY
\  &END PRINT
&END MOTION
EOF
j=0
for n in ${lat} ; do
 len=`echo "scale=15 ; $n/10" | bc`
 echo "${str}" | sed "s/dftb_opt/dftb_opt_${n}/g ; s/snap/snap_${n}/g ; s/£/\`/g" > job_dftb_opt_${n}.p
 sed "/ABC/c\
\     ABC ${len} 50 10
/PROJECT dftb_opt/c\
\  PROJECT dftb_opt_${n}
" .hef.$$ > dftb_opt_${n}.inp 
 ln -s dftb_opt-RESTART.wfn dftb_opt_${n}-RESTART.wfn 
 sbatch job_dftb_opt_${n}.p 
 echo ${j}
 j=${j}+1
done
rm .hef.$$
