#!/bin/bash
# routine to

typeset -i i j k ks

ifi=mmag_pwscf_0003_proj.out 
ili="101 102 103 104"
min=0.1
dat=false
ofi=proj_dos.dat

while getopts o:i:l:m:d opt
do
 case $opt in
  o) ofi="${OPTARG}"
  ;;
  i) ifi="${OPTARG}"
  ;;
  l) ili="${OPTARG}"
  ;;
  m) min="${OPTARG}"
  ;;
  d) dat=true
  ;;
 esac
done ; OPTIND=0

echo "#kpt #state E[eV] #electrons #list_states" > $ofi

ili=`echo "${ili}" | sed "s/ / \/p ; \/ /g"` ; ili="/ ${ili} /p;"
kpl=(0 `sed -n "/k =/= ; /Lowdin Charges/= ; " ${ifi} `)
k=1
echo $ili 
while [ ${k} -lt 5 ] ; do # ${#kpl[*]} ] ; do
 ks=${k}+1 
 str=`sed -n ${kpl[${k}]},${kpl[${ks}]}p ${ifi}`
 ell=(0 `echo "${str}" | sed -n "/e =/="`)
 pll=(0 `echo "${str}" | sed -n "/psi =/="`)
 pl2=(0 `echo "${str}" | sed -n "/|psi|^2 =/="`) 
 j=1
 while [ ${j} -lt ${#ell[*]} ] ; do
  sstr=`echo "${str}" | sed -n "${ell[${j}]},${pl2[${j}]}p"`
  fstr=`echo "${sstr}" | sed 's/\[#/ /g ; s/\]/ /g ; /e =/d ; s/psi =// ; /psi|/d ; s/+/\n/g ; s/\*/ /g ; s/  / /g' | sed -n "${ili}"`
  [ "${fstr}" == "" ] && { j=${j}+1 ; continue ; } 
  fc=(`echo "${fstr}" | awk '{ print $1}'`) 
  fd=(`echo "${fstr}" | awk '{ print $2}'`)
  fc=`echo "scale=4;${fc[*]}" | sed 's/ /+/g' | bc`
#  k: 1 j: 201 en:      e =    13.17891 eV wt: 0.002* 125
  ter=`echo "${fc} > ${min}" | bc`
  if [ "${ter}" == "1" ] ; then
   en=`echo "${str}" | sed -n ${ell[${j}]}p | awk '{ print $3 }'`
   en=`echo "scale=8 ; ${en}-(-0.8851)" | bc`
   if ${dat} ; then
    echo "${k} ${j}  ${en} " ${fc} ${fd[*]} | tee -a $ofi 
   else
    echo "k: ${k} j: ${j} en: ${en} wt:" ${fc} ${fd[*]} | tee -a $ofi
   fi
  fi
  j=${j}+1
 done
 k=${k}+3
done
exit 
sed -n "/k =   0.1000/,/k =   0.3000/{ /${hi}/p ; /psi =/p;  }" $ifi

exit

e =    13.73236 eV
     psi = 0.009*[#  87]+0.006*[#  76]+0.006*[#  72]+0.005*[#  49]+0.005*[#   9]+
          +0.004*[#  60]+0.004*[#  84]+0.004*[#  80]+0.004*[#  92]+0.004*[#  39]+
          +0.004*[# 113]+0.003*[#  68]+0.003*[#  21]+0.003*[#  71]+0.003*[#  75]+
          +0.003*[#  45]+0.002*[#   1]+0.002*[#  81]+0.002*[#  89]+0.002*[#   5]+
          +0.002*[#  25]+0.002*[#  29]+0.002*[#  65]+0.002*[#  17]+0.002*[#  77]+
          +0.002*[#  41]+0.002*[#  83]+0.001*[#  15]+0.001*[#  35]+0.001*[#  91]+
          +0.001*[#  12]+0.001*[#  52]+0.001*[#  55]+0.001*[#  95]+0.001*[# 100]+
          +0.001*[# 112]+0.001*[# 127]+0.001*[# 128]+
    |psi|^2 = 0.131
     e =    13.84093 eV
     psi = 0.008*[#  35]+0.005*[#   9]+0.005*[#  49]+0.005*[# 113]+0.004*[#  17]+
          +0.004*[#  60]+0.004*[#  41]+0.004*[#  75]+0.004*[#  67]+0.004*[#  71]+
          +0.004*[#  79]+0.003*[#  72]+0.003*[#  76]+0.003*[#  37]+0.002*[#  96]+
          +0.002*[#  59]+0.002*[#  45]+0.002*[#  64]+0.002*[#  99]+0.002*[# 111]+
          +0.002*[#  19]+0.002*[#  21]+0.002*[#  29]+0.002*[#  43]+0.002*[#  94]+
          +0.002*[#   4]+0.002*[#   5]+0.002*[#  28]+0.001*[#  12]+0.001*[#  33]+
          +0.001*[#  52]+0.001*[# 127]+0.001*[# 128]+0.001*[#  39]+0.001*[# 100]+
          +0.001*[#  51]+0.001*[#  63]+0.001*[# 112]+0.001*[# 117]+0.001*[#  11]+
          +0.001*[# 121]+
    |psi|^2 = 0.134
