#!/bin/bash
# routine to

typeset -i i j ifrp ifrf

ifi=xas.out
vibf=(`ls PH4_HT-MOLVIB-1.mol PL4-MOLVIB-1.mol *mol*`)
ofi=prc_all.dat

while getopts i:v: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  v) vibf="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT`
echo $vibf
frq=(`sed -n '/FREQ/,/FR-COORD/{ /F/d ; p ; }' ${vibf}`)
echo ${#frq[*]} 
here=`pwd`

echo "no hno frq_mol frq_phon frq_anh" > $ofi
j=0
for frql in ${frq[*]}  ; do
# frql=${frq[${j}]}
 hj=`expi -i ${j}` ; frp=N ; frf=N ; 
 if ls vib_${hj}/eig*log > /dev/null 2> /dev/null ; then
   frp=`grep phon vib_${hj}/eigenstates.log | awk '{ print $6 }'` 
   frf=`grep res vib_${hj}/eigenstates.log | awk '{ print $7 }' ` 
 #  ifrp=`echo $frp | awk -F . '{ print $1 }'`
 #  ifrf=`echo $frf | awk -F . '{ print $1 }'`
  if echo "${frf}" | grep N > /dev/null 2> /dev/null ; then 
   prc="Not_cal"
  else
   trm=`echo "100*(("${frql}")-("${frf}"))/("${frql}")"`
 #  echo "${trm}"
   prc=`echo "scale=1 ; (${trm})" | bc`
  fi
 fi
 echo ${j} ${hj}  ${frql} ${frp} ${frf} ${prc} >> ${ofi}
  j=${j}+1
#  [ ${j} -gt 3835 ] && exit 
done
cat $ofi
