#!/bin/bash
# 

typeset -i i j m k h nc
ifi=a.out
dof=ao_DOS
sig=0.1
hartev=27.2114
dl=-15 ; ul=10
ofi=dos.eps


while getopts i:o: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
 esac
done

. integer_lib

ly=(`grep " typat " ${ifi}`) # typat 1  1  1  1  2  2  2  2  3  3  3  3  3  3  3  3  3  3  3  3
ly[0]=0
n=${#lity[*]}
liz=(`grep " znucl " ${ifi}`) #  znucl     26.00000   57.00000    8.00000
atnam=("total" La Fe O)



j=0 ; k=1
eferm=`grep ermi ${dof} | awk '{ print $5 }'`

rm  obj_*.dat 
for dof in `ls *_DOS*` ; do
 hstr=`expi -i ${ly[${j}]}`
 ldof=obj_${hstr}.dat 
 echo "dof: ${dof} ldof: ${ldof}"
 sed '/^#/d ; /0.0000    0.0000    0.0000    0.0000    0.0000/d' ${dof} | awk -v ef="${eferm}" -v cf="${hartev}" '{printf"%4i %16.8f %16.8f %16.8f %16.8f %16.8f %16.8f \n", $1,($2-(ef))*cf,$3/cf,$4/cf,$5/cf,$6/cf,$7/cf}' >> ${ldof} 
 j=${j}+1  
done


ll=("" "" "s" "p" "d" "f")
bstr="" ; j=0 ; k=${j} ; h=0
for fon in obj_*.dat ; do
 for l in 2 3 4 5 ; do 
  echo "fon: ${fon}, c: ${k} , atnam: ${atnam[${j}]}, l: ${l}, k: ${k}" 
   if [ ${h} -eq 0 -a ${l} -eq 2 -o ${h} -eq 1 -a ${l} -eq 4 -o ${h} -eq 1 -a ${l} -eq 5 -o ${h} -eq 2 -a ${l} -eq 4 -o ${h} -eq 3 -a ${l} -eq 3 ] ; then
    k=${j}+1
    bstr="${bstr}FOCUS G${j}\nREAD BLOCK \"${fon}\" \nBLOCK xy \"1:${l}\"\ns${j} line color ${k}\ns${j} legend \"${atnam[${h}]}-${ll[${l}]}\" \n"
    j=${j}+1
   fi
 done
 mv $fon ${fon}.$$
 m=`wc ${fon}.$$ | awk '{print $1}'`
 nc=`head -1 ${fon}.$$ | awk '{ print NF}'`-2
 my_convolute -pnt ${m} -e1 -1000 -e2 1000 -smin ${sig} -smax ${sig} -fout ${fon} -fin ${fon}.$$ -de 0.0136057 -ncol ${nc} >> proc.log 2>> proc.log &
 h=${h}+1
done

#rm *.$$
wait

echo -e "${bstr}" > bfile 

cat >> bfile << EOF
title "LaFeO3"
xaxis label "E [eV] "
yaxis label "DOS (#/eV)"
#yaxis ticklabel off
WORLD XMIN ${dl}
WORLD XMAX ${ul}
autoscale yaxes
autoticks
PRINT TO "${ofi}"
DEVICE "EPS" OP "level2"
PRINT
exit
EOF

rm $ofi  > /dev/null 2> /dev/null
xmgrace -batch bfile -nosafe
display -rotate 90 ${ofi} &
exit 
     0   -0.80000    0.0000    0.0000
     1   -0.79950    0.0000    0.0000
     2   -0.79900    0.0000    0.0000
     3   -0.79850    0.0000    0.0000
     4   -0.79800    0.0000    0.0000
     5   -0.79750    0.0000    0.0000
