#!/bin/bash
# routine to generate pdb from espresso-output
#USAGE: pw_out+inptopdb.bash -i mmag_pwscf_0004.out -p mmag_pwscf_0004.inp  -j mmag_pwscf_0004_proj.out 
#USAGE: pw_out+inptopdb.bash -i mmag_pwscf_0004.out -p mmag_pwscf_0004.inp  # LDA+activated 

typeset -i i j n

n=4
ifi=opt_0002.out 
pfi=opt_0002.inp
jfi="" 
chgstr=""

while getopts i:p:j:c opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  p) pfi="${OPTARG}"
  ;;
  j) jfi="${OPTARG}"
  ;;
  c) chgstr=" -c"
  ;;
 esac
done ; OPTIND=0

prfx=`echo ${ifi} | sed 's/.out//g'`
ofi=${prfx}.pdb

. integer_lib

echo "le: ${le}"

hstr=`sed -n '/POSITION/,/K_POINTS/{ /POSITION/d  ; /K_POINTS/d ; p ; }'  ${pfi}` 
m=`echo "${hstr}" | wc | awk '{ print $1 }'`
echo -e "${m} \n E \n ${hstr}" > .hef.xyz.$$ 
cat ${pfi} > .hef.inp.$$
le=`grep celldm ${ifi} | head -1 | awk '{ print $2}'` ; le=`echo "scale=8 ; (${le})*0.529177" | bc`

j=0 ; 
while [ ${j} -le ${n} ] ; do
 hs=`expi -i ${j}`
 pw_out+inptopdb_h.bash -i ${ifi} -p .hef.inp.$$ -s -j "${jfi}" ${chgstr}
 mv ${ofi} .hef_${hs}.pdb.$$
 shift_center_grav_xyz -v "${le} 0 0" -i .hef.xyz.$$
 hstr=`sed 1,2d .hef.xyz.$$`
 echo -e "ATOMIC_POSITIONS (angstrom) \n ${hstr} \n K_POINTS (automatic)" > .hef.inp.$$ 
 echo ${j}
 j=${j}+1
done
head -1 .hef_0000.pdb.$$ > ${ofi} 
cat .hef_[0-9]*.pdb.$$ | sed '/CRYST/d' >> ${ofi}
cat ${ofi} 
rm .hef*$$
