#!/bin/bash
# draws dos.eps from dos-file, needs fermi-niveau
#USAGE: ./pwscf_draw_dos.bash -f -3.1013 -i staircase.dos 

typeset -i i j m
ifi=staircase.dos 
ll=-6
ul=6 
eferm=-2.9139 


while getopts i:l:u:f: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  l) ll="${OPTARG}"
  ;;
  u) ul="${OPTARG}"
  ;;
  f) eferm="${OPTARG}"
  ;;
 esac
done

. integer_lib

cat > bfile << EOF
#Obligatory descriptive comment
s0 line color 2
s1 line color 3
title "${ifi}"
s0 legend "spin up"
s1 legend "spin dn"
xaxis label "E [eV] "
yaxis label "#/E [1/eV]"
#yaxis ticklabel off
autoscale yaxes
autoticks
#print to  "mf.eps"
print
exit
EOF
sed '/eV/d' ${ifi} | awk -v ef=${eferm} '{ print FNR " " $1-(ef)" "$2*1." "$3+0.005" "0" "0 }' > .hefi.$$
m=`wc .hefi.$$ | awk '{ print $1 }'` ; sig=0.05 ; e1=-10 ; e2=10
my_convolute -de 0.01 -pnt ${m} -e1 ${e1} -e2 ${e2} -smin ${sig} -smax ${sig} -fout .heffi.$$ -fin .hefi.$$ >> proc.log 2>> proc.log
awk  '{ print  $1" "$2" "$3 }' .heffi.$$ > .hefi.$$
rm dos.eps
xmgrace -nxy .hefi.$$ -batch bfile -world ${ll} 0 ${ul} 10 -printfile dos.eps -nosafe

rm .he*.$$

exit
