#!/bin/bash
# routine to calculate vib_ with correct mass from snap_ files

typeset -i i j m k hii hkk

c=(`ls snap_0*xyz`) ; m=${#c[*]}-1
d=(`ls vib_*.dat`) 

ifi=${c[0]}
pfi=${c[${m}]}
ofi=${d}
phon=false


while getopts i:p:o:  opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  p) pfi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
 esac
done ; OPTID=0

. integer_lib

hstr=`sed '1,2d ; s/ /  /g ; s/H /1.0079/;s/He /4.0026/;s/Li /6.941/;s/Be /9.0122/;s/B /10.811/;s/C /12.0107/;s/N /14.0067/;s/O /15.9994/;s/F /18.9984/;s/Ne /20.1797/;s/Na /22.9897/;s/Mg /24.305/;s/Al /26.9815/;s/Si /28.0855/;s/P /30.9738/;s/S /32.065/;s/Cl /35.453/;s/Ar /39.948/;s/K /39.0983/;s/Ca /40.078/;s/Sc /44.9559/;s/Ti /47.867/;s/V /50.9415/;s/Cr /51.9961/;s/Mn /54.938/;s/Fe /55.845/;s/Co /58.9332/;s/Ni /58.6934/;s/Cu /63.546/;s/Zn /65.39/;s/Ga /69.723/;s/Ge /72.64/;s/As /74.9216/;s/Se /78.96/;s/Br /79.904/;s/Kr /83.8/;s/Rb /85.4678/;s/Sr /87.62/;s/Y /88.9059/;s/Zr /91.224/;s/Nb /92.9064/;s/Mo /95.94/;s/Ru /101.07/;s/Rh /102.9055/;s/Pd /106.42/;s/Ag /107.8682/;s/Cd /112.411/;s/In /114.818/;s/Sn /118.71/;s/Sb /121.76/;s/Te /127.6/;s/I /126.9045/;s/Xe /131.293/;s/Cs /132.9055/;s/Ba /137.327/;s/La /138.9055/;s/Ce /140.116/;s/Pr /140.9077/;s/Nd /144.24/;s/Sm /150.36/;s/Eu /151.964/;s/Gd /157.25/;s/Tb /158.9253/;s/Dy /162.5/;s/Ho /164.9303/;s/Er /167.259/;s/Tm /168.9342/;s/Yb /173.04/;s/Lu /174.967/;s/Hf /178.49/;s/Ta /180.9479/;s/W /183.84/;s/Re /186.207/;s/Os /190.23/;s/Ir /192.217/;s/Pt /195.078/;s/Au /196.9665/;s/Hg /200.59/;s/Tl /204.3833/;s/Pb /207.2/;s/Bi /208.9804/;s/Th /232.0381/;s/Pa /231.0359/;s/U /238.028/ ' $pfi | awk '{ print $1 " "$1 " " $1 }'`
c=(${hstr})
# echo "c: ${c[*]}" 

function mult { # multiplication scalar with vector
local i vec c
vec=$2
c=$1
typeset -i i 

co=$$ ; i=0
#echo ${vec}
for fon in ${vec} ; do
 { echo ${i} `echo "scale=8 ; (${fon})*(${c})" | bc` >> .hef.${co} ; } &
 i=${i}+1
done
wait
sort -n .hef.${co} | awk '{ print $2}' ; rm .hef.${co}
}

function vmult { # scalar product: vector multiplication with vector
local i wec vec  hstr

wec=($1)
vec=$2
typeset -i i 

co=${ofi}.$$ ; i=0
#echo ${vec}
hstr="0"
for fon in ${vec} ; do
 hstr="${hstr}+(${fon})*(${wec[${i}]})"
 i=${i}+1
done
echo "scale=8 ; ${hstr}" | bc
}

function mvmult { # matrix-vector product: multiply vector with matrix
local i mat matl vec hstr

mat=$1
vec=$2
typeset -i i 

i=1
hstr=`echo -e  ${mat}`
c=(`echo -e "${hstr}" | awk '{ print $1 }'`)
n=${#c[*]}
hstr=""
while [ ${i} -le ${n} ] ; do
 matl=`echo -e "${mat}" | head -${i} | tail -1`
 hstr="${hstr} "`vmult  "${matl}" "${vec}"`
 i=${i}+1
done
echo "${hstr}" 
}

function detmat { # calculate determinant of 3x3 matrix
local i j k mat matl vec hstr cc

mat=$1 
typeset -i i  

cc=(`echo -e "${mat} ${mat}"`)  
hstr="-((${cc[2]})* (${cc[4]})* (${cc[6]})) + (${cc[1]})* (${cc[5]})* (${cc[6]})+ (${cc[2]})* (${cc[3]})* (${cc[7]})- (${cc[0]})* (${cc[5]})* (${cc[7]})- (${cc[1]})* (${cc[3]})* (${cc[8]})+ (${cc[0]})* (${cc[4]})* (${cc[8]})"
hstr=`echo "scale=8 ; ${hstr}" | bc`
echo "${hstr}"  
}

function invmat { # calculate inverse of 3x3 matrix
local i mat matl vec hstr det

mat=$1 
typeset -i i 

cc=(`echo -e "${mat}"`) ;  
det=`detmat "${cc[*]}"`
dd="-((${cc[5]})*(${cc[7]}))+(${cc[4]})*(${cc[8]}) (${cc[2]})*(${cc[7]})-(${cc[1]})*(${cc[8]}) -((${cc[2]})*(${cc[4]}))+(${cc[1]})*(${cc[5]})  (${cc[5]})*(${cc[6]})-(${cc[3]})*(${cc[8]}) -((${cc[2]})*(${cc[6]}))+(${cc[0]})*(${cc[8]}) (${cc[2]})*(${cc[3]})-(${cc[0]})*(${cc[5]})  -((${cc[4]})*(${cc[6]}))+(${cc[3]})*(${cc[7]}) (${cc[1]})*(${cc[6]})-(${cc[0]})*(${cc[7]}) -((${cc[1]})*(${cc[3]}))+(${cc[0]})*(${cc[4]})"
#echo "det: ${det} dd: ${dd}"
dd=(`mult  "(1/(${det}))" "${dd}"`)
echo "${dd[0]} ${dd[1]} ${dd[2]}\n${dd[3]} ${dd[4]} ${dd[5]}\n${dd[6]} ${dd[7]} ${dd[8]}\n"
}

#detmat "-6 -2 3 \n -1 0.5 0 \n 5 1 -2"
#invmat "-6 -2 3 \n -1 0.5 0 \n 5 1 -2" 
# "-6 -2 3 \n -1 0.5 0 \n 5 1 -2" 

if grep "uc" $ifi >> /dev/null 2> /dev/null ; then # read unit cell
 ucs=`grep "uc" $ifi | awk -F ':' '{ print $2}'`
else
 echo "WARNING: Should take into account the units (fractional coordinates) of the ${pfi} file"
 echo "work with cubic unit cell"
 ucs="1 0 0 \n 0 1 0 \n 0 0 1\n"
fi

mx=0
for j in 1 2 3 ; do   # determine longest unit cell vector
 zi=`echo -e "$ucs" | head -${j} | tail -1`
 zi=`vmult "${zi}"  "${zi}"`
 echo "${zi} > ${mx}" | bc >> /dev/null &&  mx=${zi}
# echo "zi: ${zi} mx: ${mx}"
done
mx=`echo "scale=12 ; 1/sqrt(${mx})" | bc`
echo "mx: ${mx}"

nucs=""
for j in 1 2 3 ; do   # rescale unit cell
 zi=`echo -e "${ucs}" | head -${j} | tail -1`
 zi=`mult ${mx} "${zi}"`
 nucs="${nucs}"`echo ${zi}`"\n"
done
ics=`invmat "${nucs}"`
echo "nucs: ${nucs}"
echo "ics: ${ics}"
d=(`sed 1,2d $ifi | awk '{ print $2 " " $3 " " $4 }'`)
e=(`sed 1,2d $pfi | awk '{ print $2 " " $3 " " $4 }'`)
ad=`sed -n '2p' $ifi |  awk '{ print $1 }'`
ae=`sed -n '2p' $pfi |  awk '{ print $1 }'`
# echo "d: ${d[*]}"
# echo "e: ${e[*]}"
# echo "ad: ${ad}, ae: ${ae}" 

tdp=0 ;mum=0 ; k=0 ; i=1 
for fon in ${d[*]} ; do   # for each coordinate substract
 d[${k}]=`echo "scale=12 ; (${d[${k}]}-(${e[${k}]}))/(${ad}-(${ae}))" | bc`
# echo "d[k}: ${d[${k}]}" 
 mum="${mum}+(${d[${k}]})*(${d[${k}]})*${c[k]}"
 if [ ${i} -gt 2 ] ; then
  hii=${k}-2 ; hkk=${k}-1
  nv=(`mvmult "${ics}" "${d[${hii}]} ${d[${hkk}]} ${d[${k}]}"`)
  d[${hii}]=${nv[0]} ; 
  d[${hkk}]=${nv[1]} ; 
  d[${k}]="${nv[2]} \n"
  i=0  
 fi
 k=${k}+1 ; i=${i}+1 
done   # atomic mass unit to electron mass: 1822.88839
mum=`echo "scale=8 ; ((${mum})*1822.88839) "  | bc ` # angst to bohr: 1.88973
hhstr=(`ls vib_[0-9]*.dat`)
c=(`head -1 ${hhstr}`)
echo -e "#mass ${mum} ${c[2]} recalc ${c[*]} \n ${d[*]}" > ${ofi}
str=`sed '/mass/d' naliz.dat`
echo -e "${str} \n#mass ${mum}" > naliz.dat
cat $ofi 
exit
