#!/bin/bash
# routine to

typeset -i i j

ifi=xas.out
kll=false
emt=false
tm="24:00:00"

while getopts i:t:ke opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  k) kll=true
  ;;
  e) kll=true 
     emt=true
  ;;
  t) tm="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

if $kll ; then
 jl=`qstat -u adj | grep "MgMnN.mmag"  | awk -F . '{ print $1 }'`
 if $emt ; then
 jl=`qstat -u adj | grep "MgMnN.mmag"  | grep Q | awk -F . '{ print $1 }'`
 fi
 echo "jl: "${jl}
 qdel  $jl
 exit
fi

j=0
for que in infiniband infinijazz ; do
 case $que in 
  infiniband)  lat=" 4 4 2 1 1"
  ;;
  infinijazz)  lat=" 4 4 4 4 2 2  1 1"
  ;;
 esac
 echo $lat
 for n in ${lat} ; do
  cat > .hef.$$ << EOF
#PBS -N MgMnN.mmag.band
#PBS -l walltime=${tm} 
#PBS -l nodes=${n}:ppn=8 
#PBS -q ${que}
#PBS -j oe
ulimit -s unlimited
typeset -i i 
dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"
i=1
while [ \${i} -lt 100000000000000000 ] ; do
 sleep 1
 rm MgMnN.mmag.band*
 i=\${i}+1
done 

EOF
  sbatch  .hef.$$
  sleep 1
#  rm .hef.$$
  echo ${j}
  j=${j}+1
 done
done
