#!/bin/bash
# routine to

typeset -i i j
ofi=naliz
inxl="000000" # works also with a list of indices
vig=false
wai=`pwd | awk -F / '{ x=NF-1 ; print $x }'`

while getopts w:l:v opt
do
 case $opt in
  w) wai="${OPTARG}"
  ;;
  l) inxl="${OPTARG}"
  ;;
  v) vig=true #vigurous: remove previous save file 
  ;;
 esac
done ; OPTIND=0

SCRIPT=`readlink -f $0`
SCRIPTPATH=`dirname $SCRIPT`
PATH=${SCRIPTPATH}:${PATH}

ls *out || exit 
mss=(`ls snap_0*[0-9].xyz`)
mss=`sed -n '/mass/{s/mass/\n mass/ ; p ; }' ${mss} | grep mass | awk '{ print $2 }'`

ls ${ofi}.[a-z]* > /dev/null 2> /dev/null && rm ${ofi}.[a-z]*
for fon in `ls ${wai}*inp` ; do
 raz=`echo $fon | sed 's/\.inp//'`
 #echo "raz: ${raz}"
 inx=`echo ${raz} | sed 's/\./_/ ; s/[a-z]//g ; s/__/_/g' | awk -F _ '{ print $NF }'` 
 if   sed -n '/PROGRAM ENDED AT/p'  ${raz}.out > /dev/null 2> /dev/null ; then
  astr=`sed -n '/E/p' snap_${inx}.xyz  | awk '{ print $1 " "$3 }'`
  eng=`sed -n '/ENERGY| Total/p' ${raz}.out | awk '{ print $9 }' | tail -1`
  eng=`echo "scale=6 ; (${eng})*2" | bc` # conversion from bohr to hartree
  echo "${astr} ${eng}" >> ${ofi}.dat
  str=`sed  "/job/{ /_${raz}/d ;  }" list_job.txt` ; echo -e "${str}" > list_job.txt 
 else
  echo "sbatch job_${raz}.p" >> list_job.txt
 fi 
done
sort -n -k 1 ${ofi}.dat > .hef.$$
echo -e "#amp j energ[Ry] mass[m_e]: \n#mass ${mss} \n#maxen 2\n#verbos mid" > ${ofi}.dat
cat .hef.$$ >> ${ofi}.dat 
amp=`sed '/#/d' ${ofi}.dat | sort -n | head -1 | awk '{ print $1 }'`
i=`echo "scale=3; int(abs(${amp}))" | funcs.bc`
if [ ${i} -lt 1 ] ; then
 echo "#ymax 1" >> ${ofi}.dat
fi
echo "#ndim 200" >> ${ofi}.dat

cat ${ofi}.dat
 
here=`pwd | awk -F / '{ print $NF }'`

while read lin ; do 
echo ${lin} >> ${ofi}.xmgr
done << EOF
# xmgrace -hardcopy  -noask -noprint -nosafe -batch ${ofi}.xmgr 
title "V(f) ${here}"
focus g0
s0 symbol 2
s0 symbol size 0.560000
s0 symbol color 1 
s0 symbol pattern 1
s0 symbol fill color 2 
s0 symbol fill pattern 1
s0 symbol linewidth 1.0
s0 symbol linestyle 1
s0 symbol char 0
s0 symbol char font 4
s0 symbol skip 0
read block "${ofi}.dat" 
block xy "1:3"
push
focus g1
s1 line linestyle 2
s1 symbol type 2
read block "fit.dat"
block xy "2:3"
pop
#s0 legend "up"
yaxis label "E [Ry]"
xaxis label "f [a.u.]"
autoticks
print to "${ofi}.svg"
hardcopy device "SVG"
print
print to "${ofi}.png"
hardcopy device "PNG"
print 
s1.y=s1.y-min(s0.y)
s0.y=s0.y-min(s0.y)
world xmin -1
world xmax 1
world ymax 0.1
world ymin -0.01
autoticks
print to "${ofi}_zoom.svg"
hardcopy device "SVG"
print to "${ofi}_zoom.png"
hardcopy device "PNG"
print
exit
EOF
#if [ ${i} -lt 1 ] ; then
# harmapp.bash
#fi

eigenstates.x  > eigenstates.log 
rm ${ofi}*svg ${ofi}*eps ${ofi}*png 
xmgrace -hardcopy  -noask -noprint -nosafe -batch ${ofi}.xmgr 

