#!/bin/bash
# routine to smoothen and print phonon dos

typeset -i i j

ifi=cryo.dos
sig=10

while getopts i:s: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  s) sig="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib
#lat="1 2 4"
#j=0
#for n in ${lat} ; do
# echo ${j}
# j=${j}+1
#done

awk ' { print NR  " " $1 " " $2 }' $ifi > ${ifi}.conv
rm smear.log >  /dev/null  2> /dev/null
~/tools_try/my_convolute.x -smin ${sig}  -smax ${sig} -fin ${ifi}.conv -fout .hef.$$ -de 1 -ncol 1   >> smear.log 2>> smear.log
cp .hef.$$ ${ifi}.conv
# echo "ech 1"
# head ${ifi}.conv
# echo "ech 2"
# head .hef.$$ 

cat > ${ifi}.conv.xmgr << EOF
# xmgrace -nosafe -batch ${ifi}.xmgr
title "Phonon DOS"
focus g0
focus g0
read block "${ifi}.conv"
block xy "2:1"
yaxis label  "\x  w  \0 [cm-1]"
xaxis label "DOS [a.u.]"
autoticks
print to "${ifi}.conv.svg"
hardcopy device "SVG"
print
print to "${ifi}.conv.eps"
hardcopy device "EPS"
print
exit
EOF

rm ${ifi}.conv*eps ${ifi}.conv*svg 
xmgrace -nosafe -batch ${ifi}.conv.xmgr  
display ${ifi}.conv.eps & 
