#!/bin/bash
# routine to

typeset -i i j k l jinx

ifi=xas.out
date=`date +%Y_%m_%d`
ofi=quality_${date}.dat
rfi=(`ls dynmat.out matdyn.modes`)  # cryo.dyn1, if matdyn not converged

while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib

lat=`ls -d vib_[0-9][0-9][0-9][0-9] | sed 's/vib_//g'`
echo $lat
r=(`sed -n '/\*\*\*\*\*\*/=' ${rfi}`)
# define whether keyword is freq or omega: 
if grep freq $rfi > /dev/null 2> /dev/null ; then 
 kwd=freq 
 str=`sed -n "${r[0]},${r[1]}{ s/( /(/g ; p ; }" ${rfi} | grep ${kwd} `
 refv=(`echo "${str}" | awk '{ print $8 }' `)
else
 kwd=omega ;
 str=`sed -n "${r[0]},${r[1]}{ s/( /(/g ; p ; }" ${rfi} | grep ${kwd} `
 refv=(`echo "${str}" | awk '{ print $6 }' `)
fi
 
ofil=`ls vib_*/*out`
# echo "${str}" ; echo "${refv[*]}" ; exit

echo "#index(vib) index(matdyn) lambda(vib)[cm-1] lambda(matdyn)[cm-1] error[%] dev_harmosz1[%] dev_harmosz2[%]  dev_harmosz3[%]  lowest_energy[Ry] no_datapts" > ${ofi}

j=0 ; aprc="scale=3 ;(0 "
for inx in ${lat} ; do
 jinx=`piex -i ${inx}` ; k=${jinx}+1 ; #[ ${jinx} -gt 30 ] && exit
 hk=`expi -i ${k} -l 2`
 eigv=`grep resonance vib_${inx}/eigenstates.log | awk '{ print $7}'`
 prp=(`grep "oscillator proportions" vib_${inx}/eigenstates.log | awk '{ print $7" "$8" "$9 }'`)
 echo "inx: ${inx}, jinx: ${jinx}, k: ${k}, prp: ${prp[*]}"
 l=0
 for z in ${prp[*]} ; do
  prp[${l}]=`echo "scale=3 ; 100*(${z}-((${l}+1)*2+1))/((${l}+1)*2+1)" | bc`
  l=${l}+1
 done
 #resonance frequency in Hz (cm^-1):     0.12512282E+14       417.3648711
 prc=`echo "scale=2 ; 100*((${eigv})-(${refv[${jinx}]}))/${refv[${jinx}]}" | bc`
 aprc="${aprc}+(${prc})"
 loen=`head -3 vib_${inx}/eigenstates.dat | tail -1 | awk '{ print $2 }'` 
 hstr=""
 hofil=`echo "${ofil}" | grep "vib_${inx}"`
 for fon in ${hofil} ; do  
  hstr="${hstr}"`tail -200 $fon`
 done  
 nofi=`echo "${hstr}" | grep "convergence has been achieved" | wc | awk '{ print $1 }'`
 echo "vib_${inx} omega(${jinx}) ${eigv} |" ${refv[${jinx}]} "| ${prc} | ${prp[0]} | ${prp[1]} | ${prp[2]} | ${loen} | ${nofi}" >> ${ofi}
 # [ ${j} -gt 0 ] && break
 j=${j}+1
done
 echo "${aprc})/${j}" | bc >> $ofi 
 cat $ofi
exit
drwxr-xr-x 5 adj127 users 20480 Apr 22 14:59 vib_0020
drwxr-xr-x 3 adj127 users 12288 Apr 22 14:58 vib_0059
drwxr-xr-x 3 adj127 users 12288 Apr 22 14:58 vib_0058
drwxr-xr-x 3 adj127 users 12288 Apr 22 14:58 vib_0057
drwxr-xr-x 3 adj127 users  4096 Apr 22 14:58 vib_0056
drwxr-xr-x 5 adj127 users  4096 Apr 22 14:58 vib_0055
drwxr-xr-x 5 adj127 users 12288 Apr 22 14:58 vib_0054
drwxr-xr-x 3 adj127 users  4096 Apr 22 14:57 vib_0053
drwxr-xr-x 3 adj127 users  4096 Apr 22 14:57 vib_0052
     omega(13) =       4.363548 [THz] =     145.553272 [cm-1]
     omega(14) =       4.535331 [THz] =     151.283350 [cm-1]
     omega(15) =       4.643067 [THz] =     154.877083 [cm-1]
     omega(16) =       4.744560 [THz] =     158.262535 [cm-1]
     omega(17) =       5.096156 [THz] =     169.990607 [cm-1]
     omega(18) =       5.137909 [THz] =     171.383324 [cm-1]
     omega(19) =       5.139041 [THz] =     171.421105 [cm-1]
     omega(20) =       5.581600 [THz] =     186.183385 [cm-1]
     omega(21) =       5.884125 [THz] =     196.274587 [cm-1]
     omega(22) =       6.094959 [THz] =     203.307314 [cm-1]
