#!/bin/bash
# routine to

typeset -i i j

ifi=xas.out
ofi=naliz

while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

SCRIPT=`readlink -f $0`
SCRIPTPATH=`dirname $SCRIPT`
PATH=${SCRIPTPATH}:${PATH}

for fon in vib_00[0-2]* ; do 
 cd $fon 
 jl=(`ls snap_*xyz`)
 recalcvib.bash -o ${fon}.dat  -i ${jl[0]} -p ${jl[1]} 
 str=`sed '/#mass/d; /#ymax/d ;/#maxen/d; ' ${ofi}.dat`
 nmass=`grep mass   ${fon}.dat`
 amp=`sed '/#/d' ${ofi}.dat | sort -n |  tail -1   | awk '{ print $1 }'`
 i=`echo "scale=3; int(abs(${amp}))" | funcs.bc`
 if [ ${i} -lt 1 ] ; then
  echo "#ymax 1" >> ${ofi}.dat
 fi
 echo -e "${str} \n ${nmass}" > ${ofi}.dat
 rm eigen* ; eigenstates.x > eigenstates.log 
 eigenstates.x > eigenstates.log 
 str=`sed "/V/{s/)/) ${fon}/; }"  ${ofi}.xmgr`
 echo -e "${str}" > ${ofi}.xmgr


 rm ${ofi}.eps ${ofi}.svg
 xmgrace -nosafe -batch ${ofi}.xmgr
 cd ..  
 exit
done 
 
