#!/bin/bash
# routine to

typeset -i i j m

ifi=xas.out
wt="02:59:00"
ntask=20
nnode=1
# ppn="nodes=3:ppn=8"


while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib

j=0
#for n in ${lat} ; do
# echo ${j}
# j=${j}+1
#done
ldir=`pwd | awk -F / '{ print $NF }'`
c=(`pwd | sed 's/\// /g'`)
m=${#c[*]}-2 ; hn=${c[${m}]}


cat > job_${hn}_${ldir}.p << EOFF
#!/bin/bash
#SBATCH --job-name="${hn}_${ldir}"
#SBATCH --nodes=${nnode}
#SBATCH --ntasks=${ntask}
#SBATCH --time=${wt}
##SBATCH --mem-per-cpu=4GB
#SBATCH --partition=empi
#    User              Account  Partition 
#    dadams         grp_churakov       empi 
#    dadams                  geo      short 
#    dadams                  geo       empi 
#    dadams                  geo        all 

module load openmpi/1.10.2-intel
OMP_NUM_THREADS=\$SLURM_CPUS_PER_TASK
echo ~
dstr=\`date\`
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}"

PATH=~/bin:\${PATH}:~/qe/qe-6.0/bin/:\`dirname \$(readlink -f \$0)\`
module load mvapich2
which pw.x
echo "HOSTNAME: \${HOSTNAME} date: \${dstr}"
pwd
afi=\`ls *[0-9].inp | shuf\`
for fli in \${afi} ; do
 flih=\`echo \$fli | sed 's/\.inp//'\`
 export INP=\${flih}
 if grep "convergence has been achieved" \$INP.out 2> /dev/null ; then
  echo "done \$INP.inp"
 else
  sed "/restart_mode/c\\
   restart_mode=\'restart\'
  " \$INP.inp > .hef.\$$
   mv .hef.\$$ \$INP.inp
  echo "do \$INP.inp"
  mv \$INP.out.bak-2 \$INP.out.bak-3 ; mv \$INP.out.bak-1 \$INP.out.bak-2 ; mv \$INP.out \$INP.out.bak-1
#  mpiexec -np \${NSLOTS}  pw.x  -npools 2 <  > 
  mpirun pw.x -ni 2 -nk 1 -nt 1 -nd 2 -i ./\$INP.inp > \$INP.out
  rm -r \${INP}.save 
#  tar -czf \${INP}.save.tar.gz \${INP}.save && rm -r \${INP}.save 
 fi
done 
./nbearb -n 1 
EOFF


 
