#!/bin/bash
# routine to extract positions from output of pwscf and write it to xyz format 

typeset -i i j k l 

ifi=one_units_lsd.out 
ofi=snap_mag.xyz
tag=" E "
direct=false

while getopts i:c:o:t: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
  t) tag="${OPTARG}"
  ;;
 esac
done ; OPTID=0


lsk=(`grep "     celldm(1)" ${ifi} | awk '{ print $2 }'`)
if grep CELL_PARAM ${ifi} > /dev/null 2> /dev/null ; then 
 mc=`sed -n '/CELL_PARAM/,/ATOMIC_POSITIONS/{ /P/d ; /\./p; }' ${ifi} | awk '{ print $1 "  " $2 "  " $3 }'`
else
 mc=`sed -n '/crystal axes:/,/reciproc/{ /co/d ; /\./p; }' ${ifi} | awk '{ print $4 "  " $5 "  " $6 }' | head -3`
fi 

if grep CELL_PARAM ${ifi} > /dev/null 2> /dev/null ; then
 rstr=""
while read dlin ; do
 c=(${dlin})
 for i in 0 1 2 ; do
  c[${i}]=`echo "scale=8 ; (${c[${i}]})" | bc`
 done
# echo "c[*]: ${c[*]}"
 rstr="${rstr} ${c[*]} \n"
done << EOOF
${mc}
EOOF
else 
rstr=""
while read dlin ; do
 c=(${dlin})
 for i in 0 1 2 ; do
  c[${i}]=`echo "scale=8 ; (${lsk})*0.529177*(${c[${i}]})" | bc`
 done
# echo "c[*]: ${c[*]}"
 rstr="${rstr} ${c[*]} \n"
done << EOOF
${mc}
EOOF
fi 
#echo "rstr: ${rstr}"
#exit

grep "ATOMIC_POSITIONS (angstrom" ${ifi} > /dev/null 2> /dev/null && direct=true
sed -n '/ATOMIC_POSITIONS/,/K_POINTS/{ /ATOMIC_POSITIONS/d ; /K_POINTS/d ; p ;}' ${ifi} > .hefi.$$  
wc .hefi.$$ | awk '{ print $1 }' > ${ofi} 
echo "${tag} uc: ${rstr}" >> ${ofi}
exec 3< .hefi.$$

while read dlin ; do
 a=(${dlin})
 b=(${a[0]} 0. 0. 0.)
 for j in 1 2 3 ; do 
  if $direct ; then
   b[${j}]="(${a[${j}]})"
  else
  for k in 1 2 3 ; do 
    c=(- `echo -e "${rstr}" | sed -n ${k}p`)
#   echo "c: ${c[*]}"
    b[${j}]=${b[${j}]}"+(${c[${j}]})*(${a[${k}]})"
  done
  fi
  b[${j}]=`echo "scale=8 ; ${b[${j}]}" | bc`
# echo "j: ${j} c: ${c[*]}"
 done
 echo "${b[*]}" | awk '{ printf "%10s %16.8f %16.8f %16.8f \n" , $1,$2,$3,$4}' >> ${ofi} # | tee -a ${ofi} 
done <&3

#cat ${ofi} 
rm .hefi.$$ 
