#!/bin/bash
# routine to rotate coordinates of file containing positions in xyz-format

typeset -i i j k l nc

ifi=opt_pwscf_101.out 
ofi=run.xyz

while getopts i:c:o: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
 esac
done ; OPTID=0

. integer_lib

sed -n '/ATOMIC_POSITIONS/,/ATOMIC_POSITIONS/p' ${ifi} > snip

if grep "CELL_PARAMETERS" snip && grep "Writing output" snip ; then 
 c=(`sed -n '/CELL_PARAMETERS/=; /Writing output/=; /A final scf calculation/=' ${ifi}`)
else
 c=(`sed -n '/ATOMIC_POSITIONS/=; /CELL_PARAMETERS/=; /Writing output/=; /A final scf calculation/=' ${ifi}`)
fi
nps=(`sed -n '/ATOMIC_POSITIONS/p' snip | awk '{ print $1 }'`) ; nps=${#nps[*]}
echo "nps: ${nps}"
#[ ${nps} -gt 1 ] || grep "Error in " ${ifi} ||  c=(`sed -n '/ATOMIC_POSITIONS/=; /Writing output/=; /A final scf calculation/=' ${ifi}`)
rm snip
el=(`sed -n '/!    total energy/p' ${ifi} | awk '{ print $5 }'`)
echo ${c[*]}
nc=${#c[*]}-1

i=0 ; k=${i}+1
while [ ${k} -lt ${nc} ] ; do
 hstr=`expi -i ${i}`
 sed -n "/crystal axes:/,/reciproc/p ; s/final/K_POINTS/ ; /celldm(1)/p ; ${c[${i}]},${c[${k}]}{ 
/Writing output/c\
K_POINTS
/lsda relaxation/c\
K_POINTS
; /^$/d ; p; }" ${ifi} > .hefi.${hstr}.$$   
orl=(`sed -n '/crystal axes:/= ; /reciproca/=' .hefi.${hstr}.$$`)
if [ ${#orl[*]} -gt 2 ] ; then 
 str=`sed ${orl[0]},${orl[1]}d  .hefi.${hstr}.$$`
 echo "${str}" > .hefi.${hstr}.$$
fi
# grep "End final coo" .hefi.${hstr}.$$ && { cat .hefi.${hstr}.$$  ; } 
# [ ${k} -gt 4 ] && break 
 i=${i}+2 ; k=${i}+1
done   
 

i=0
for fon in .hefi.*.$$ ; do
 hstr=`expi -i ${i}`
 viz_pwscf.bash -i ${fon} -o .heffi.${hstr}.$$ -t " ${i} E ${el[${i}]} Ry" &
 i=${i}+1 
done
wait  
cat .heffi.*.$$ > ${ofi}
exit
rm .hefi.*.$$ .heffi.*.$$

exit
