#!/bin/bash
# routine to

typeset -i i j m

ifi=xas.out
wt="11:59:00"
ppn="2:ppn=16"

while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

#. integer_lib

j=0
#for n in ${lat} ; do
# echo ${j}
# j=${j}+1
#done
ldir=`pwd | awk -F / '{ print $NF }' | sed 's/v/w/g'`
c=(`pwd | sed 's/\// /g'`)
m=${#c[*]}-2 ; hn=${c[${m}]}


cat > job_${hn}_${ldir}.p << EOFF
#!/bin/bash
#PBS -N ${hn}_${ldir}
#PBS -l walltime=${wt}
#PBS -q short
#PBS -l nodes=${ppn}
#PBS -j oe
ulimit -s unlimited
typeset -i j k l rnodes
PATH=~/bin:/share/apps/espresso/espresso-5.0.3/bin:/home/apps/bin:\${PATH}:\`dirname \$(readlink -f \$0)\`
module load mvapich2
cd \$PBS_O_WORKDIR
export mnslots=8 # number of cpus to be used for each mpiexec
export house=house.\$\$
export NSLOTS=\`cat \$PBS_NODEFILE | wc -l | awk '{ print \$1 }'\` ; dstr=\`date\`
echo \${NSLOTS} > \$house
[ \${mnslots} -gt \${NSLOTS} ] && { echo " not enough nodes" ; exit ; } 
echo "HOSTNAME: \${HOSTNAME} PBS_JOBNAME: \${PBS_JOBNAME} PBS_JOBID: \${PBS_JOBID} date: \${dstr}: house: \${house} NSLOTS: \${NSLOTS}"
afi=\`ls *[0-9].inp | shuf\`
j=0
export hef=\`pwd\`"/hef"
for fli in \${afi} ; do
 export INP=\`echo \$fli | sed 's/\.inp//'\`
 if grep "JOB DONE" \$INP.out 2> /dev/null ; then
  echo "done \$INP.inp"
 else
  echo "do \$INP.inp"
  while true  ; do
   export rnodes=\`cat \${house}\` # number of remaining nodes
   echo "house: \${house} INP: \${INP} rnodes: \${rnodes} mnslots: \${mnslots}"
   if [ \${rnodes} -ge \${mnslots} ] ; then 
    cd \$PBS_O_WORKDIR
    pwd
    export rnodes=\${rnodes}-\${mnslots} ; echo "\${rnodes}" >  \${house}
    mv \$INP.out.bak-2 \$INP.out.bak-3 ; mv \$INP.out.bak-1 \$INP.out.bak-2 ; mv \$INP.out \$INP.out.bak-1 ;
   { echo "star" >> \${hef} ; mpirun -np \${mnslots} pw.x -npools 2 < ./\$INP.inp > \$INP.out ; tar -czf \${INP}.save.tar.gz \${INP}.save && rm -r \${INP}.save ; rnodes=\`cat \${house}\`+\${mnslots} ; echo  \${rnodes}  > \${house} ; } &  
    echo "house: \${house} INP: \${INP} rnodes: \${rnodes} mnslots: \${mnslots}" >> \$hef
    sleep 5 
    break
   else
    sleep 10
   fi
   j=\${j}+1
  done
 fi
done 
wait
rm \$house
./nbearb -n 1 
EOFF
