#!/bin/bash
# routine to

typeset -i i j

ifi=snap.xyz
ofi=pos.rec

while getopts i:o: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
  o) ofi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib
. vector_lib
SCRIPT=`readlink -f $0` ; SCRIPTPATH=`dirname $SCRIPT` 

mc=`head -2 $ifi | tail -1 | sed 's/uc: /\n/g'`
mc=`echo -e "${mc}" | tail -4 | head -3 `
lsk=1



rstr=""
while read dlin ; do
 c=(${dlin})
 for i in 0 1 2 ; do
  c[${i}]=`echo "scale=8 ; (${lsk})*(${c[${i}]})" | bc` #*0.529177
 done
# echo "c[*]: ${c[*]}"
 rstr="${rstr} ${c[*]} \n"
done << EOOF
${mc}
EOOF
#echo "rstr: ${rstr}"
echo -e "rstr: ${rstr}"
echo "c: ${c[*]}" ; 

# calculate inverse lattice vectors:
v=(`echo -e "${rstr}" | head -1 | tail -1`)
w=(`echo -e "${rstr}" | head -2 | tail -1`)
z=(`echo -e "${rstr}" | head -3 | tail -1`)
x=(`cr -v "${v[*]}" -w "${w[*]}"`)
det=`sp -v "${x[*]}" -w "${z[*]}"`
i=0; 
for eexp in "(${w[1]})*(${z[2]})-(${w[2]})*(${z[1]})" "-(${v[1]})*(${z[2]})+(${v[2]})*(${z[1]})" "(${v[1]})*(${w[2]})-(${v[2]})*(${w[1]})" "(${w[2]})*(${z[0]})-(${w[0]})*(${z[2]})" "-(${v[2]})*(${z[0]})+(${v[0]})*(${z[2]})" "(${v[2]})*(${w[0]})-(${v[0]})*(${w[2]})" "(${w[0]})*(${z[1]})-(${w[1]})*(${z[0]})" "-(${v[0]})*(${z[1]})+(${v[1]})*(${z[0]})" "(${v[0]})*(${w[1]})-(${v[1]})*(${w[0]})"; do
# echo "eexp: ${eexp}"
 d[${i}]=`echo "scale=15 ; (${eexp})/(${det}) "| bc` #
 i=${i}+1
done
echo "det: ${det} d: ${d[*]}"
sstr="${d[0]} ${d[1]} ${d[2]}\n ${d[3]} ${d[4]} ${d[5]}\n ${d[6]} ${d[7]} ${d[8]}\n "
echo -e "${sstr}"
echo -e "${rstr}"

sed 1,2d ${ifi} > .hefi.$$  
wc .hefi.$$ | awk '{ print $1 }' > ${ofi} 
echo "${tag} uc: ${rstr}" >> ${ofi}
exec 3< .hefi.$$

cat .hefi.$$
cat $ofi 

while read dlin ; do
 a=(${dlin})
 b=(${a[0]} 0. 0. 0.)
 for j in 1 2 3 ; do 
  for k in 1 2 3 ; do 
    c=(- `echo -e "${sstr}" | sed -n ${k}p`)
#   echo "c: ${c[*]}"
    b[${j}]=${b[${j}]}"+(${c[${j}]})*(${a[${k}]})"
  done
  b[${j}]=`echo "scale=8 ; ${b[${j}]}" | bc`
# echo "j: ${j} c: ${c[*]}"
 done
 echo "${b[*]}" | awk '{ printf "%10s %16.8f %16.8f %16.8f \n" , $1,$2,$3,$4}' >> ${ofi} # | tee -a ${ofi} 
done <&3

#cat ${ofi} 
rm .hefi.$$ 
