#!/bin/bash
# routine to

typeset -i i j

ofi=naliz_zoom.xmgr

while getopts i: opt
do
 case $opt in
  i) ifi="${OPTARG}"
  ;;
 esac
done ; OPTIND=0

. integer_lib

lat="1 2 4"

j=0
for fon in vib_* ; do
 cd $fon
echo "# xmgrace -nosafe -batch naliz_zoom.xmgr" > $ofi
while read lin ; do
echo $lin >> $ofi
done << EOF
title "V(f) ${fon}"
with g0
s0 line linestyle 2
s0 symbol type 2
read block "fit.dat"
block xy "2:3" 
yaxis label "E [Ry]"
xaxis label "q [a.u.]"
focus g1
s1 symbol 2
s1 symbol skip 0
s1 symbol size 0.560000
s1 symbol color 1
s1 symbol pattern 1
s1 symbol fill color 2
s1 symbol fill pattern 1
s1 symbol linewidth 1.0
s1 symbol linestyle 1
s1 symbol char 0
s1 symbol char font 4
read block "naliz.dat" 
block xy "1:3"
s1.y=s1.y-min(s0.y)
s0.y=s0.y-min(s0.y)
world xmin -1
world xmax 1
world ymax 0.1
world ymin -0.01
autoticks
print to "naliz_zoom.svg"
hardcopy device "SVG"
print
print to "naliz_zoom.png"
hardcopy device "PNG"
print
exit
EOF
rm naliz_zoom.svg  naliz_zoom.png
xmgrace -nosafe -batch naliz_zoom.xmgr 
 cd ..
 j=${j}+1
done
